// Here we have routines which only define the momentum config we need, 
// and not the other 23!
#include "WJets.h"
#include "MomentumDef.h"

  // p1 = b(+) a(-) --> e nu + -,   p2 = b(+) a(-) --> e nu - +
  // p3 = a(-) b(+) --> e nu - +,   p4 = a(-) b(+) --> e nu + -

int MDtemp2[4][6]={{0,1,2,3,4,5}, //1
		   {0,1,2,3,5,4}, //2
		   {1,0,2,3,5,4}, //3
		   {1,0,2,3,4,5}  //4
};

  // p1 = b(+) a(-) --> e nu + 0 -,   p2 = a(-) b(+) --> e nu - 0 +
  // p3 = b(+) a(-) --> e nu 0 + -,   p4 = b(+) a(-) --> e nu + - 0
  // p5 = b(+) a(-) --> e nu - 0 +,   p6 = b(+) a(-) --> e nu 0 - +
  // p7 = b(+) a(-) --> e nu - + 0,   p8 = a(-) b(+) --> e nu 0 - +
  // p9 = a(-) b(+) --> e nu - + 0,   p10= a(-) b(+) --> e nu + 0 -
  // p11= a(-) b(+) --> e nu 0 + -,   p12= a(-) b(+) --> e nu + - 0

int MDtemp3[12][7]={{0,1,2,3,4,5,6}, //1
		   {1,0,2,3,6,5,4}, //2
		   {0,1,2,3,5,4,6}, //3
		   {0,1,2,3,4,6,5}, //4
		   {0,1,2,3,6,5,4}, //5
		   {0,1,2,3,5,6,4}, //6
		   {0,1,2,3,6,4,5}, //7
		   {1,0,2,3,5,6,4}, //8
		   {1,0,2,3,6,4,5}, //9
		   {1,0,2,3,4,5,6}, //10
		   {1,0,2,3,5,4,6}, //11
		   {1,0,2,3,4,6,5}  //12
};
int MDtemp[48][8]={{0,1,2,3,4,5,6,7}, //1
		 {0,1,2,3,4,5,7,6}, //2
		 {0,1,2,3,4,6,5,7}, //3
		 {0,1,2,3,4,6,7,5}, //4
		 {0,1,2,3,4,7,5,6}, //5
		 {0,1,2,3,4,7,6,5}, //6
		 {0,1,2,3,5,4,6,7}, //7
		 {0,1,2,3,5,4,7,6}, //8
		 {0,1,2,3,5,6,4,7}, //9
		 {0,1,2,3,5,6,7,4}, //10
		 {0,1,2,3,5,7,4,6}, //11
		 {0,1,2,3,5,7,6,4}, //12
		 {0,1,2,3,7,6,5,4}, //13
		 {0,1,2,3,7,6,4,5}, //14
		 {0,1,2,3,7,5,6,4}, //15
		 {0,1,2,3,7,5,4,6}, //16
		 {0,1,2,3,7,4,6,5}, //17
		 {0,1,2,3,7,4,5,6}, //18
		 {0,1,2,3,6,7,5,4}, //19
		 {0,1,2,3,6,7,4,5}, //20
		 {0,1,2,3,6,5,7,4}, //21
		 {0,1,2,3,6,5,4,7}, //22
		 {0,1,2,3,6,4,7,5}, //23
		 {0,1,2,3,6,4,5,7}, //24
                 {1,0,2,3,7,6,5,4}, //25
		 {1,0,2,3,7,6,4,5}, //26
		 {1,0,2,3,7,5,6,4}, //27
		 {1,0,2,3,7,5,4,6}, //28
		 {1,0,2,3,7,4,6,5}, //29
		 {1,0,2,3,7,4,5,6}, //30
		 {1,0,2,3,6,7,5,4}, //31
		 {1,0,2,3,6,7,4,5}, //32
		 {1,0,2,3,6,5,7,4}, //33
		 {1,0,2,3,6,5,4,7}, //34
		 {1,0,2,3,6,4,7,5}, //35
		 {1,0,2,3,6,4,5,7}, //36
		 {1,0,2,3,4,5,6,7}, //37
		 {1,0,2,3,4,5,7,6}, //38
		 {1,0,2,3,4,6,5,7}, //39
		 {1,0,2,3,4,6,7,5}, //40
		 {1,0,2,3,4,7,5,6}, //41
		 {1,0,2,3,4,7,6,5}, //42
		 {1,0,2,3,5,4,6,7}, //43
		 {1,0,2,3,5,4,7,6}, //44
		 {1,0,2,3,5,6,4,7}, //45
		 {1,0,2,3,5,6,7,4}, //46
		 {1,0,2,3,5,7,4,6}, //47
		 {1,0,2,3,5,7,6,4}  //48
};
  // p1 = b(+) a(-) --> e nu + 0 -,   p2 = a(-) b(+) --> e nu - 0 +
  // p3 = b(+) a(-) --> e nu 0 + -,   p4 = b(+) a(-) --> e nu + - 0
  // p5 = b(+) a(-) --> e nu - 0 +,   p6 = b(+) a(-) --> e nu 0 - +
  // p7 = b(+) a(-) --> e nu - + 0,   p8 = a(-) b(+) --> e nu 0 - +
  // p9 = a(-) b(+) --> e nu - + 0,   p10= a(-) b(+) --> e nu + 0 -
  // p11= a(-) b(+) --> e nu 0 + -,   p12= a(-) b(+) --> e nu + - 0

  // qi = pi with e and nu swapped (for e- nubar final states)

void CWMultijet::Def3jp1()
{
  pmg3[0][0]=pb.e();
  pmg3[0][1]=pb.x();
  pmg3[0][2]=pb.y();
  pmg3[0][3]=pb.z();
  
  pmg3[1][0]=pa.e();
  pmg3[1][1]=pa.x();
  pmg3[1][2]=pa.y();
  pmg3[1][3]=pa.z();
  
  pmg3[2][0]=pd1.e();   // +ve lepton
  pmg3[2][1]=pd1.x();
  pmg3[2][2]=pd1.y();
  pmg3[2][3]=pd1.z();
  
  pmg3[3][0]=pd2.e();   // neutrino
  pmg3[3][1]=pd2.x();
  pmg3[3][2]=pd2.y();
  pmg3[3][3]=pd2.z();
  
  pmg3[4][0]=(partonmomenta.back()).e();   // most forward jet
  pmg3[4][1]=(partonmomenta.back()).x();
  pmg3[4][2]=(partonmomenta.back()).y();
  pmg3[4][3]=(partonmomenta.back()).z();
  
  pmg3[5][0]=(partonmomenta.at(1)).e();  // middle jet
  pmg3[5][1]=(partonmomenta.at(1)).x();
  pmg3[5][2]=(partonmomenta.at(1)).y();
  pmg3[5][3]=(partonmomenta.at(1)).z();
  
  pmg3[6][0]=(partonmomenta.front()).e();  // most backward jet
  pmg3[6][1]=(partonmomenta.front()).x();
  pmg3[6][2]=(partonmomenta.front()).y();
  pmg3[6][3]=(partonmomenta.front()).z();

  alepton.PID=-11;
  alepton.p=pd1;
  lepton.PID=12;
  lepton.p=pd2;
}

void CWMultijet::Def3jq1()
{
  pmg3[0][0]=pb.e();
  pmg3[0][1]=pb.x();
  pmg3[0][2]=pb.y();
  pmg3[0][3]=pb.z();
  
  pmg3[1][0]=pa.e();
  pmg3[1][1]=pa.x();
  pmg3[1][2]=pa.y();
  pmg3[1][3]=pa.z();
  
  pmg3[2][0]=pd2.e();   // neutrino
  pmg3[2][1]=pd2.x();
  pmg3[2][2]=pd2.y();
  pmg3[2][3]=pd2.z();
  
  pmg3[3][0]=pd1.e();   // -ve lepton
  pmg3[3][1]=pd1.x();
  pmg3[3][2]=pd1.y();
  pmg3[3][3]=pd1.z();
  
  pmg3[4][0]=(partonmomenta.back()).e();   // most forward jet
  pmg3[4][1]=(partonmomenta.back()).x();
  pmg3[4][2]=(partonmomenta.back()).y();
  pmg3[4][3]=(partonmomenta.back()).z();
  
  pmg3[5][0]=(partonmomenta.at(1)).e();  // middle jet
  pmg3[5][1]=(partonmomenta.at(1)).x();
  pmg3[5][2]=(partonmomenta.at(1)).y();
  pmg3[5][3]=(partonmomenta.at(1)).z();
  
  pmg3[6][0]=(partonmomenta.front()).e();  // most backward jet
  pmg3[6][1]=(partonmomenta.front()).x();
  pmg3[6][2]=(partonmomenta.front()).y();
  pmg3[6][3]=(partonmomenta.front()).z();

  alepton.PID=-12;
  alepton.p=pd2;
  lepton.PID=11;
  lepton.p=pd1;
}

void CWMultijet::Def3jp2()
{
  pmg3[0][0]=pa.e();
  pmg3[0][1]=pa.x();
  pmg3[0][2]=pa.y();
  pmg3[0][3]=pa.z();
  
  pmg3[1][0]=pb.e();
  pmg3[1][1]=pb.x();
  pmg3[1][2]=pb.y();
  pmg3[1][3]=pb.z();
  
  pmg3[2][0]=pd1.e();   // +ve lepton
  pmg3[2][1]=pd1.x();
  pmg3[2][2]=pd1.y();
  pmg3[2][3]=pd1.z();
  
  pmg3[3][0]=pd2.e();   // neutrino
  pmg3[3][1]=pd2.x();
  pmg3[3][2]=pd2.y();
  pmg3[3][3]=pd2.z();
  
  pmg3[4][0]=(partonmomenta.front()).e();   // most backward jet
  pmg3[4][1]=(partonmomenta.front()).x();
  pmg3[4][2]=(partonmomenta.front()).y();
  pmg3[4][3]=(partonmomenta.front()).z();
  
  pmg3[5][0]=(partonmomenta.at(1)).e();  // middle jet
  pmg3[5][1]=(partonmomenta.at(1)).x();
  pmg3[5][2]=(partonmomenta.at(1)).y();
  pmg3[5][3]=(partonmomenta.at(1)).z();
  
  pmg3[6][0]=(partonmomenta.back()).e();  // most forward jet
  pmg3[6][1]=(partonmomenta.back()).x();
  pmg3[6][2]=(partonmomenta.back()).y();
  pmg3[6][3]=(partonmomenta.back()).z();

  alepton.PID=-11;
  alepton.p=pd1;
  lepton.PID=12;
  lepton.p=pd2;
}

void CWMultijet::Def3jq2()
{
  pmg3[0][0]=pa.e();
  pmg3[0][1]=pa.x();
  pmg3[0][2]=pa.y();
  pmg3[0][3]=pa.z();
  
  pmg3[1][0]=pb.e();
  pmg3[1][1]=pb.x();
  pmg3[1][2]=pb.y();
  pmg3[1][3]=pb.z();
  
  pmg3[2][0]=pd2.e();   // anti-neutrino
  pmg3[2][1]=pd2.x();
  pmg3[2][2]=pd2.y();
  pmg3[2][3]=pd2.z();
  
  pmg3[3][0]=pd1.e();   // -ve lepton
  pmg3[3][1]=pd1.x();
  pmg3[3][2]=pd1.y();
  pmg3[3][3]=pd1.z();
  
  pmg3[4][0]=(partonmomenta.front()).e();   // most backward jet
  pmg3[4][1]=(partonmomenta.front()).x();
  pmg3[4][2]=(partonmomenta.front()).y();
  pmg3[4][3]=(partonmomenta.front()).z();
  
  pmg3[5][0]=(partonmomenta.at(1)).e();  // middle jet
  pmg3[5][1]=(partonmomenta.at(1)).x();
  pmg3[5][2]=(partonmomenta.at(1)).y();
  pmg3[5][3]=(partonmomenta.at(1)).z();
  
  pmg3[6][0]=(partonmomenta.back()).e();  // most forward jet
  pmg3[6][1]=(partonmomenta.back()).x();
  pmg3[6][2]=(partonmomenta.back()).y();
  pmg3[6][3]=(partonmomenta.back()).z();

  alepton.PID=-12;
  alepton.p=pd2;
  lepton.PID=11;
  lepton.p=pd1;
}

void CWMultijet::Def3jp3()
{
  pmg3[0][0]=pb.e();
  pmg3[0][1]=pb.x();
  pmg3[0][2]=pb.y();
  pmg3[0][3]=pb.z();
  
  pmg3[1][0]=pa.e();
  pmg3[1][1]=pa.x();
  pmg3[1][2]=pa.y();
  pmg3[1][3]=pa.z();
  
  pmg3[2][0]=pd1.e();   // +ve lepton
  pmg3[2][1]=pd1.x();
  pmg3[2][2]=pd1.y();
  pmg3[2][3]=pd1.z();
  
  pmg3[3][0]=pd2.e();   // neutrino
  pmg3[3][1]=pd2.x();
  pmg3[3][2]=pd2.y();
  pmg3[3][3]=pd2.z();
  
  pmg3[4][0]=(partonmomenta.at(1)).e();   // middle jet
  pmg3[4][1]=(partonmomenta.at(1)).x();
  pmg3[4][2]=(partonmomenta.at(1)).y();
  pmg3[4][3]=(partonmomenta.at(1)).z();
  
  pmg3[5][0]=(partonmomenta.back()).e();  // forward jet
  pmg3[5][1]=(partonmomenta.back()).x();
  pmg3[5][2]=(partonmomenta.back()).y();
  pmg3[5][3]=(partonmomenta.back()).z();
  
  pmg3[6][0]=(partonmomenta.front()).e();  // most backward jet
  pmg3[6][1]=(partonmomenta.front()).x();
  pmg3[6][2]=(partonmomenta.front()).y();
  pmg3[6][3]=(partonmomenta.front()).z();

  alepton.PID=-11;
  alepton.p=pd1;
  lepton.PID=12;
  lepton.p=pd2;
}

void CWMultijet::Def3jq3()
{
  pmg3[0][0]=pb.e();
  pmg3[0][1]=pb.x();
  pmg3[0][2]=pb.y();
  pmg3[0][3]=pb.z();
  
  pmg3[1][0]=pa.e();
  pmg3[1][1]=pa.x();
  pmg3[1][2]=pa.y();
  pmg3[1][3]=pa.z();
  
  pmg3[2][0]=pd2.e();   // neutrino
  pmg3[2][1]=pd2.x();
  pmg3[2][2]=pd2.y();
  pmg3[2][3]=pd2.z();
  
  pmg3[3][0]=pd1.e();   // -ve lepton
  pmg3[3][1]=pd1.x();
  pmg3[3][2]=pd1.y();
  pmg3[3][3]=pd1.z();
  
  pmg3[4][0]=(partonmomenta.at(1)).e();   // middle jet
  pmg3[4][1]=(partonmomenta.at(1)).x();
  pmg3[4][2]=(partonmomenta.at(1)).y();
  pmg3[4][3]=(partonmomenta.at(1)).z();
  
  pmg3[5][0]=(partonmomenta.back()).e();  // forward jet
  pmg3[5][1]=(partonmomenta.back()).x();
  pmg3[5][2]=(partonmomenta.back()).y();
  pmg3[5][3]=(partonmomenta.back()).z();
  
  pmg3[6][0]=(partonmomenta.front()).e();  // most backward jet
  pmg3[6][1]=(partonmomenta.front()).x();
  pmg3[6][2]=(partonmomenta.front()).y();
  pmg3[6][3]=(partonmomenta.front()).z();

  alepton.PID=-12;
  alepton.p=pd2;
  lepton.PID=11;
  lepton.p=pd1;
}

void CWMultijet::Def3jp4()
{
  pmg3[0][0]=pb.e();
  pmg3[0][1]=pb.x();
  pmg3[0][2]=pb.y();
  pmg3[0][3]=pb.z();
  
  pmg3[1][0]=pa.e();
  pmg3[1][1]=pa.x();
  pmg3[1][2]=pa.y();
  pmg3[1][3]=pa.z();
  
  pmg3[2][0]=pd1.e();   // +ve lepton
  pmg3[2][1]=pd1.x();
  pmg3[2][2]=pd1.y();
  pmg3[2][3]=pd1.z();
  
  pmg3[3][0]=pd2.e();   // neutrino
  pmg3[3][1]=pd2.x();
  pmg3[3][2]=pd2.y();
  pmg3[3][3]=pd2.z();
  
  pmg3[4][0]=(partonmomenta.back()).e();   // most forward jet
  pmg3[4][1]=(partonmomenta.back()).x();
  pmg3[4][2]=(partonmomenta.back()).y();
  pmg3[4][3]=(partonmomenta.back()).z();
  
  pmg3[5][0]=(partonmomenta.front()).e();  // backward
  pmg3[5][1]=(partonmomenta.front()).x();
  pmg3[5][2]=(partonmomenta.front()).y();
  pmg3[5][3]=(partonmomenta.front()).z();
  
  pmg3[6][0]=(partonmomenta.at(1)).e();  // middle
  pmg3[6][1]=(partonmomenta.at(1)).x();
  pmg3[6][2]=(partonmomenta.at(1)).y();
  pmg3[6][3]=(partonmomenta.at(1)).z();

  alepton.PID=-11;
  alepton.p=pd1;
  lepton.PID=12;
  lepton.p=pd2;
}

void CWMultijet::Def3jq4()
{
  pmg3[0][0]=pb.e();
  pmg3[0][1]=pb.x();
  pmg3[0][2]=pb.y();
  pmg3[0][3]=pb.z();
  
  pmg3[1][0]=pa.e();
  pmg3[1][1]=pa.x();
  pmg3[1][2]=pa.y();
  pmg3[1][3]=pa.z();
  
  pmg3[2][0]=pd2.e();   // neutrino
  pmg3[2][1]=pd2.x();
  pmg3[2][2]=pd2.y();
  pmg3[2][3]=pd2.z();
  
  pmg3[3][0]=pd1.e();   // -ve lepton
  pmg3[3][1]=pd1.x();
  pmg3[3][2]=pd1.y();
  pmg3[3][3]=pd1.z();
  
  pmg3[4][0]=(partonmomenta.back()).e();   // most forward jet
  pmg3[4][1]=(partonmomenta.back()).x();
  pmg3[4][2]=(partonmomenta.back()).y();
  pmg3[4][3]=(partonmomenta.back()).z();
  
  pmg3[5][0]=(partonmomenta.front()).e();  // backward
  pmg3[5][1]=(partonmomenta.front()).x();
  pmg3[5][2]=(partonmomenta.front()).y();
  pmg3[5][3]=(partonmomenta.front()).z();
  
  pmg3[6][0]=(partonmomenta.at(1)).e();  // middle
  pmg3[6][1]=(partonmomenta.at(1)).x();
  pmg3[6][2]=(partonmomenta.at(1)).y();
  pmg3[6][3]=(partonmomenta.at(1)).z();

  alepton.PID=-12;
  alepton.p=pd2;
  lepton.PID=11;
  lepton.p=pd1;
}

void CWMultijet::Def3jp5()
{
  pmg3[0][0]=pb.e();
  pmg3[0][1]=pb.x();
  pmg3[0][2]=pb.y();
  pmg3[0][3]=pb.z();
  
  pmg3[1][0]=pa.e();
  pmg3[1][1]=pa.x();
  pmg3[1][2]=pa.y();
  pmg3[1][3]=pa.z();
  
  pmg3[2][0]=pd1.e();   // +ve lepton
  pmg3[2][1]=pd1.x();
  pmg3[2][2]=pd1.y();
  pmg3[2][3]=pd1.z();
  
  pmg3[3][0]=pd2.e();   // neutrino
  pmg3[3][1]=pd2.x();
  pmg3[3][2]=pd2.y();
  pmg3[3][3]=pd2.z();
  
  pmg3[4][0]=(partonmomenta.front()).e();   // most backward jet
  pmg3[4][1]=(partonmomenta.front()).x();
  pmg3[4][2]=(partonmomenta.front()).y();
  pmg3[4][3]=(partonmomenta.front()).z();
  
  pmg3[5][0]=(partonmomenta.at(1)).e();  // middle
  pmg3[5][1]=(partonmomenta.at(1)).x();
  pmg3[5][2]=(partonmomenta.at(1)).y();
  pmg3[5][3]=(partonmomenta.at(1)).z();
  
  pmg3[6][0]=(partonmomenta.back()).e();  // forward
  pmg3[6][1]=(partonmomenta.back()).x();
  pmg3[6][2]=(partonmomenta.back()).y();
  pmg3[6][3]=(partonmomenta.back()).z();

  alepton.PID=-11;
  alepton.p=pd1;
  lepton.PID=12;
  lepton.p=pd2;
}

void CWMultijet::Def3jq5()
{
  pmg3[0][0]=pb.e();
  pmg3[0][1]=pb.x();
  pmg3[0][2]=pb.y();
  pmg3[0][3]=pb.z();
  
  pmg3[1][0]=pa.e();
  pmg3[1][1]=pa.x();
  pmg3[1][2]=pa.y();
  pmg3[1][3]=pa.z();
  
  pmg3[2][0]=pd2.e();   // neutrino
  pmg3[2][1]=pd2.x();
  pmg3[2][2]=pd2.y();
  pmg3[2][3]=pd2.z();
  
  pmg3[3][0]=pd1.e();   // -ve lepton
  pmg3[3][1]=pd1.x();
  pmg3[3][2]=pd1.y();
  pmg3[3][3]=pd1.z();
  
  pmg3[4][0]=(partonmomenta.front()).e();   // most backward jet
  pmg3[4][1]=(partonmomenta.front()).x();
  pmg3[4][2]=(partonmomenta.front()).y();
  pmg3[4][3]=(partonmomenta.front()).z();
  
  pmg3[5][0]=(partonmomenta.at(1)).e();  // middle
  pmg3[5][1]=(partonmomenta.at(1)).x();
  pmg3[5][2]=(partonmomenta.at(1)).y();
  pmg3[5][3]=(partonmomenta.at(1)).z();
  
  pmg3[6][0]=(partonmomenta.back()).e();  // forward
  pmg3[6][1]=(partonmomenta.back()).x();
  pmg3[6][2]=(partonmomenta.back()).y();
  pmg3[6][3]=(partonmomenta.back()).z();

  alepton.PID=-12;
  alepton.p=pd2;
  lepton.PID=11;
  lepton.p=pd1;
}

void CWMultijet::Def3jp6()
{
  pmg3[0][0]=pb.e();
  pmg3[0][1]=pb.x();
  pmg3[0][2]=pb.y();
  pmg3[0][3]=pb.z();
  
  pmg3[1][0]=pa.e();
  pmg3[1][1]=pa.x();
  pmg3[1][2]=pa.y();
  pmg3[1][3]=pa.z();
  
  pmg3[2][0]=pd1.e();   // +ve lepton
  pmg3[2][1]=pd1.x();
  pmg3[2][2]=pd1.y();
  pmg3[2][3]=pd1.z();
  
  pmg3[3][0]=pd2.e();   // neutrino
  pmg3[3][1]=pd2.x();
  pmg3[3][2]=pd2.y();
  pmg3[3][3]=pd2.z();
  
  pmg3[4][0]=(partonmomenta.at(1)).e();   // middle
  pmg3[4][1]=(partonmomenta.at(1)).x();
  pmg3[4][2]=(partonmomenta.at(1)).y();
  pmg3[4][3]=(partonmomenta.at(1)).z();
  
  pmg3[5][0]=(partonmomenta.front()).e();  // backward
  pmg3[5][1]=(partonmomenta.front()).x();
  pmg3[5][2]=(partonmomenta.front()).y();
  pmg3[5][3]=(partonmomenta.front()).z();
  
  pmg3[6][0]=(partonmomenta.back()).e();  // forward
  pmg3[6][1]=(partonmomenta.back()).x();
  pmg3[6][2]=(partonmomenta.back()).y();
  pmg3[6][3]=(partonmomenta.back()).z();

  alepton.PID=-11;
  alepton.p=pd1;
  lepton.PID=12;
  lepton.p=pd2;
}

void CWMultijet::Def3jq6()
{
  pmg3[0][0]=pb.e();
  pmg3[0][1]=pb.x();
  pmg3[0][2]=pb.y();
  pmg3[0][3]=pb.z();
  
  pmg3[1][0]=pa.e();
  pmg3[1][1]=pa.x();
  pmg3[1][2]=pa.y();
  pmg3[1][3]=pa.z();
  
  pmg3[2][0]=pd2.e();   // neutrino
  pmg3[2][1]=pd2.x();
  pmg3[2][2]=pd2.y();
  pmg3[2][3]=pd2.z();
  
  pmg3[3][0]=pd1.e();   // -ve lepton
  pmg3[3][1]=pd1.x();
  pmg3[3][2]=pd1.y();
  pmg3[3][3]=pd1.z();
  
  pmg3[4][0]=(partonmomenta.at(1)).e();   // middle
  pmg3[4][1]=(partonmomenta.at(1)).x();
  pmg3[4][2]=(partonmomenta.at(1)).y();
  pmg3[4][3]=(partonmomenta.at(1)).z();
  
  pmg3[5][0]=(partonmomenta.front()).e();  // backward
  pmg3[5][1]=(partonmomenta.front()).x();
  pmg3[5][2]=(partonmomenta.front()).y();
  pmg3[5][3]=(partonmomenta.front()).z();
  
  pmg3[6][0]=(partonmomenta.back()).e();  // forward
  pmg3[6][1]=(partonmomenta.back()).x();
  pmg3[6][2]=(partonmomenta.back()).y();
  pmg3[6][3]=(partonmomenta.back()).z();

  alepton.PID=-12;
  alepton.p=pd2;
  lepton.PID=11;
  lepton.p=pd1;
}

void CWMultijet::Def3jp7()
{
  pmg3[0][0]=pb.e();
  pmg3[0][1]=pb.x();
  pmg3[0][2]=pb.y();
  pmg3[0][3]=pb.z();
  
  pmg3[1][0]=pa.e();
  pmg3[1][1]=pa.x();
  pmg3[1][2]=pa.y();
  pmg3[1][3]=pa.z();
  
  pmg3[2][0]=pd1.e();   // +ve lepton
  pmg3[2][1]=pd1.x();
  pmg3[2][2]=pd1.y();
  pmg3[2][3]=pd1.z();
  
  pmg3[3][0]=pd2.e();   // neutrino
  pmg3[3][1]=pd2.x();
  pmg3[3][2]=pd2.y();
  pmg3[3][3]=pd2.z();
  
  pmg3[4][0]=(partonmomenta.front()).e();   // backward
  pmg3[4][1]=(partonmomenta.front()).x();
  pmg3[4][2]=(partonmomenta.front()).y();
  pmg3[4][3]=(partonmomenta.front()).z();
  
  pmg3[5][0]=(partonmomenta.back()).e();  // forward
  pmg3[5][1]=(partonmomenta.back()).x();
  pmg3[5][2]=(partonmomenta.back()).y();
  pmg3[5][3]=(partonmomenta.back()).z();
  
  pmg3[6][0]=(partonmomenta.at(1)).e();  // middle
  pmg3[6][1]=(partonmomenta.at(1)).x();
  pmg3[6][2]=(partonmomenta.at(1)).y();
  pmg3[6][3]=(partonmomenta.at(1)).z();

  alepton.PID=-11;
  alepton.p=pd1;
  lepton.PID=12;
  lepton.p=pd2;
}

void CWMultijet::Def3jq7()
{
  pmg3[0][0]=pb.e();
  pmg3[0][1]=pb.x();
  pmg3[0][2]=pb.y();
  pmg3[0][3]=pb.z();
  
  pmg3[1][0]=pa.e();
  pmg3[1][1]=pa.x();
  pmg3[1][2]=pa.y();
  pmg3[1][3]=pa.z();
  
  pmg3[2][0]=pd2.e();   // neutrino
  pmg3[2][1]=pd2.x();
  pmg3[2][2]=pd2.y();
  pmg3[2][3]=pd2.z();
  
  pmg3[3][0]=pd1.e();   // -ve lepton
  pmg3[3][1]=pd1.x();
  pmg3[3][2]=pd1.y();
  pmg3[3][3]=pd1.z();
  
  pmg3[4][0]=(partonmomenta.front()).e();   // backward
  pmg3[4][1]=(partonmomenta.front()).x();
  pmg3[4][2]=(partonmomenta.front()).y();
  pmg3[4][3]=(partonmomenta.front()).z();
  
  pmg3[5][0]=(partonmomenta.back()).e();  // forward
  pmg3[5][1]=(partonmomenta.back()).x();
  pmg3[5][2]=(partonmomenta.back()).y();
  pmg3[5][3]=(partonmomenta.back()).z();
  
  pmg3[6][0]=(partonmomenta.at(1)).e();  // middle
  pmg3[6][1]=(partonmomenta.at(1)).x();
  pmg3[6][2]=(partonmomenta.at(1)).y();
  pmg3[6][3]=(partonmomenta.at(1)).z();

  alepton.PID=-12;
  alepton.p=pd2;
  lepton.PID=11;
  lepton.p=pd1;
}

void CWMultijet::Def3jp8()
{
  //  std::cout<<pa<<"\n"<<pb<<"\n"<<pd1<<"\n"<<pd2<<"\n"<<partonmomenta.front()<<"\n"<<partonmomenta.at(1)<<"\n"<<partonmomenta.back()<<"\n";
  pmg3[0][0]=pa.e();
  pmg3[0][1]=pa.x();
  pmg3[0][2]=pa.y();
  pmg3[0][3]=pa.z();
  
  pmg3[1][0]=pb.e();
  pmg3[1][1]=pb.x();
  pmg3[1][2]=pb.y();
  pmg3[1][3]=pb.z();
  
  pmg3[2][0]=pd1.e();   // +ve lepton
  pmg3[2][1]=pd1.x();
  pmg3[2][2]=pd1.y();
  pmg3[2][3]=pd1.z();
  
  pmg3[3][0]=pd2.e();   // neutrino
  pmg3[3][1]=pd2.x();
  pmg3[3][2]=pd2.y();
  pmg3[3][3]=pd2.z();
  
  pmg3[4][0]=(partonmomenta.at(1)).e();   // middle jet
  pmg3[4][1]=(partonmomenta.at(1)).x();
  pmg3[4][2]=(partonmomenta.at(1)).y();
  pmg3[4][3]=(partonmomenta.at(1)).z();
  
  pmg3[5][0]=(partonmomenta.front()).e();  // most backward jet
  pmg3[5][1]=(partonmomenta.front()).x();
  pmg3[5][2]=(partonmomenta.front()).y();
  pmg3[5][3]=(partonmomenta.front()).z();
  
  pmg3[6][0]=(partonmomenta.back()).e();  // most forward jet
  pmg3[6][1]=(partonmomenta.back()).x();
  pmg3[6][2]=(partonmomenta.back()).y();
  pmg3[6][3]=(partonmomenta.back()).z();

  alepton.PID=-11;
  alepton.p=pd1;
  lepton.PID=12;
  lepton.p=pd2;
}

void CWMultijet::Def3jq8()
{
  //  std::cout<<pa<<"\n"<<pb<<"\n"<<pd1<<"\n"<<pd2<<"\n"<<partonmomenta.front()<<"\n"<<partonmomenta.at(1)<<"\n"<<partonmomenta.back()<<"\n";
  pmg3[0][0]=pa.e();
  pmg3[0][1]=pa.x();
  pmg3[0][2]=pa.y();
  pmg3[0][3]=pa.z();
  
  pmg3[1][0]=pb.e();
  pmg3[1][1]=pb.x();
  pmg3[1][2]=pb.y();
  pmg3[1][3]=pb.z();
  
  pmg3[2][0]=pd2.e();   // -ve lepton
  pmg3[2][1]=pd2.x();
  pmg3[2][2]=pd2.y();
  pmg3[2][3]=pd2.z();
  
  pmg3[3][0]=pd1.e();   // anti-neutrino
  pmg3[3][1]=pd1.x();
  pmg3[3][2]=pd1.y();
  pmg3[3][3]=pd1.z();
  
  pmg3[4][0]=(partonmomenta.at(1)).e();   // middle jet
  pmg3[4][1]=(partonmomenta.at(1)).x();
  pmg3[4][2]=(partonmomenta.at(1)).y();
  pmg3[4][3]=(partonmomenta.at(1)).z();
  
  pmg3[5][0]=(partonmomenta.front()).e();  // most backward jet
  pmg3[5][1]=(partonmomenta.front()).x();
  pmg3[5][2]=(partonmomenta.front()).y();
  pmg3[5][3]=(partonmomenta.front()).z();
  
  pmg3[6][0]=(partonmomenta.back()).e();  // most forward jet
  pmg3[6][1]=(partonmomenta.back()).x();
  pmg3[6][2]=(partonmomenta.back()).y();
  pmg3[6][3]=(partonmomenta.back()).z();

  alepton.PID=-12;
  alepton.p=pd2;
  lepton.PID=11;
  lepton.p=pd1;
}

void CWMultijet::Def3jp9()
{
  //  std::cout<<pa<<"\n"<<pb<<"\n"<<pd1<<"\n"<<pd2<<"\n"<<partonmomenta.front()<<"\n"<<partonmomenta.at(1)<<"\n"<<partonmomenta.back()<<"\n";
  pmg3[0][0]=pa.e();
  pmg3[0][1]=pa.x();
  pmg3[0][2]=pa.y();
  pmg3[0][3]=pa.z();
  
  pmg3[1][0]=pb.e();
  pmg3[1][1]=pb.x();
  pmg3[1][2]=pb.y();
  pmg3[1][3]=pb.z();
  
  pmg3[2][0]=pd1.e();   // +ve lepton
  pmg3[2][1]=pd1.x();
  pmg3[2][2]=pd1.y();
  pmg3[2][3]=pd1.z();
  
  pmg3[3][0]=pd2.e();   // neutrino
  pmg3[3][1]=pd2.x();
  pmg3[3][2]=pd2.y();
  pmg3[3][3]=pd2.z();
  
  pmg3[4][0]=(partonmomenta.front()).e();   // most backward
  pmg3[4][1]=(partonmomenta.front()).x();
  pmg3[4][2]=(partonmomenta.front()).y();
  pmg3[4][3]=(partonmomenta.front()).z();
  
  pmg3[5][0]=(partonmomenta.back()).e();  // most forward 
  pmg3[5][1]=(partonmomenta.back()).x();
  pmg3[5][2]=(partonmomenta.back()).y();
  pmg3[5][3]=(partonmomenta.back()).z();
  
  pmg3[6][0]=(partonmomenta.at(1)).e();  // middle
  pmg3[6][1]=(partonmomenta.at(1)).x();
  pmg3[6][2]=(partonmomenta.at(1)).y();
  pmg3[6][3]=(partonmomenta.at(1)).z();

  alepton.PID=-11;
  alepton.p=pd1;
  lepton.PID=12;
  lepton.p=pd2;
}

void CWMultijet::Def3jq9()
{
  //  std::cout<<pa<<"\n"<<pb<<"\n"<<pd1<<"\n"<<pd2<<"\n"<<partonmomenta.front()<<"\n"<<partonmomenta.at(1)<<"\n"<<partonmomenta.back()<<"\n";
  pmg3[0][0]=pa.e();
  pmg3[0][1]=pa.x();
  pmg3[0][2]=pa.y();
  pmg3[0][3]=pa.z();
  
  pmg3[1][0]=pb.e();
  pmg3[1][1]=pb.x();
  pmg3[1][2]=pb.y();
  pmg3[1][3]=pb.z();
  
  pmg3[2][0]=pd2.e();   // -ve lepton
  pmg3[2][1]=pd2.x();
  pmg3[2][2]=pd2.y();
  pmg3[2][3]=pd2.z();
  
  pmg3[3][0]=pd1.e();   // anti-neutrino
  pmg3[3][1]=pd1.x();
  pmg3[3][2]=pd1.y();
  pmg3[3][3]=pd1.z();
  
  pmg3[4][0]=(partonmomenta.front()).e();   // most backward
  pmg3[4][1]=(partonmomenta.front()).x();
  pmg3[4][2]=(partonmomenta.front()).y();
  pmg3[4][3]=(partonmomenta.front()).z();
  
  pmg3[5][0]=(partonmomenta.back()).e();  // most forward
  pmg3[5][1]=(partonmomenta.back()).x();
  pmg3[5][2]=(partonmomenta.back()).y();
  pmg3[5][3]=(partonmomenta.back()).z();
  
  pmg3[6][0]=(partonmomenta.at(1)).e();  // middle
  pmg3[6][1]=(partonmomenta.at(1)).x();
  pmg3[6][2]=(partonmomenta.at(1)).y();
  pmg3[6][3]=(partonmomenta.at(1)).z();

  alepton.PID=-12;
  alepton.p=pd2;
  lepton.PID=11;
  lepton.p=pd1;
}

void CWMultijet::Def3jp10()
{
  //  std::cout<<pa<<"\n"<<pb<<"\n"<<pd1<<"\n"<<pd2<<"\n"<<partonmomenta.front()<<"\n"<<partonmomenta.at(1)<<"\n"<<partonmomenta.back()<<"\n";

  pmg3[0][0]=pa.e();
  pmg3[0][1]=pa.x();
  pmg3[0][2]=pa.y();
  pmg3[0][3]=pa.z();
  
  pmg3[1][0]=pb.e();
  pmg3[1][1]=pb.x();
  pmg3[1][2]=pb.y();
  pmg3[1][3]=pb.z();
  
  pmg3[2][0]=pd1.e();   // +ve lepton
  pmg3[2][1]=pd1.x();
  pmg3[2][2]=pd1.y();
  pmg3[2][3]=pd1.z();
  
  pmg3[3][0]=pd2.e();   // neutrino
  pmg3[3][1]=pd2.x();
  pmg3[3][2]=pd2.y();
  pmg3[3][3]=pd2.z();
  
  pmg3[4][0]=(partonmomenta.back()).e();   // most forward jet
  pmg3[4][1]=(partonmomenta.back()).x();
  pmg3[4][2]=(partonmomenta.back()).y();
  pmg3[4][3]=(partonmomenta.back()).z();
  
  pmg3[5][0]=(partonmomenta.at(1)).e();  // middle jet
  pmg3[5][1]=(partonmomenta.at(1)).x();
  pmg3[5][2]=(partonmomenta.at(1)).y();
  pmg3[5][3]=(partonmomenta.at(1)).z();
  
  pmg3[6][0]=(partonmomenta.front()).e();  // most backward jet
  pmg3[6][1]=(partonmomenta.front()).x();
  pmg3[6][2]=(partonmomenta.front()).y();
  pmg3[6][3]=(partonmomenta.front()).z();

  alepton.PID=-11;
  alepton.p=pd1;
  lepton.PID=12;
  lepton.p=pd2;
}

void CWMultijet::Def3jq10()
{
  //  std::cout<<pa<<"\n"<<pb<<"\n"<<pd1<<"\n"<<pd2<<"\n"<<partonmomenta.front()<<"\n"<<partonmomenta.at(1)<<"\n"<<partonmomenta.back()<<"\n";

  pmg3[0][0]=pa.e();
  pmg3[0][1]=pa.x();
  pmg3[0][2]=pa.y();
  pmg3[0][3]=pa.z();
  
  pmg3[1][0]=pb.e();
  pmg3[1][1]=pb.x();
  pmg3[1][2]=pb.y();
  pmg3[1][3]=pb.z();
  
  pmg3[2][0]=pd2.e();   // -ve lepton
  pmg3[2][1]=pd2.x();
  pmg3[2][2]=pd2.y();
  pmg3[2][3]=pd2.z();
  
  pmg3[3][0]=pd1.e();   // anti-neutrino
  pmg3[3][1]=pd1.x();
  pmg3[3][2]=pd1.y();
  pmg3[3][3]=pd1.z();
  
  pmg3[4][0]=(partonmomenta.back()).e();   // most forward jet
  pmg3[4][1]=(partonmomenta.back()).x();
  pmg3[4][2]=(partonmomenta.back()).y();
  pmg3[4][3]=(partonmomenta.back()).z();
  
  pmg3[5][0]=(partonmomenta.at(1)).e();  // middle jet
  pmg3[5][1]=(partonmomenta.at(1)).x();
  pmg3[5][2]=(partonmomenta.at(1)).y();
  pmg3[5][3]=(partonmomenta.at(1)).z();
  
  pmg3[6][0]=(partonmomenta.front()).e();  // most backward jet
  pmg3[6][1]=(partonmomenta.front()).x();
  pmg3[6][2]=(partonmomenta.front()).y();
  pmg3[6][3]=(partonmomenta.front()).z();

  alepton.PID=-12;
  alepton.p=pd2;
  lepton.PID=11;
  lepton.p=pd1;
}

void CWMultijet::Def3jp11()
{
  //  std::cout<<pa<<"\n"<<pb<<"\n"<<pd1<<"\n"<<pd2<<"\n"<<partonmomenta.front()<<"\n"<<partonmomenta.at(1)<<"\n"<<partonmomenta.back()<<"\n";

  pmg3[0][0]=pa.e();
  pmg3[0][1]=pa.x();
  pmg3[0][2]=pa.y();
  pmg3[0][3]=pa.z();
  
  pmg3[1][0]=pb.e();
  pmg3[1][1]=pb.x();
  pmg3[1][2]=pb.y();
  pmg3[1][3]=pb.z();
  
  pmg3[2][0]=pd1.e();   // +ve lepton
  pmg3[2][1]=pd1.x();
  pmg3[2][2]=pd1.y();
  pmg3[2][3]=pd1.z();
  
  pmg3[3][0]=pd2.e();   // neutrino
  pmg3[3][1]=pd2.x();
  pmg3[3][2]=pd2.y();
  pmg3[3][3]=pd2.z();
  
  pmg3[4][0]=(partonmomenta.at(1)).e();   // middle
  pmg3[4][1]=(partonmomenta.at(1)).x();
  pmg3[4][2]=(partonmomenta.at(1)).y();
  pmg3[4][3]=(partonmomenta.at(1)).z();
  
  pmg3[5][0]=(partonmomenta.back()).e();  // most forward
  pmg3[5][1]=(partonmomenta.back()).x();
  pmg3[5][2]=(partonmomenta.back()).y();
  pmg3[5][3]=(partonmomenta.back()).z();
  
  pmg3[6][0]=(partonmomenta.front()).e();  // most backward jet
  pmg3[6][1]=(partonmomenta.front()).x();
  pmg3[6][2]=(partonmomenta.front()).y();
  pmg3[6][3]=(partonmomenta.front()).z();

  alepton.PID=-11;
  alepton.p=pd1;
  lepton.PID=12;
  lepton.p=pd2;
}

void CWMultijet::Def3jq11()
{
  //  std::cout<<pa<<"\n"<<pb<<"\n"<<pd1<<"\n"<<pd2<<"\n"<<partonmomenta.front()<<"\n"<<partonmomenta.at(1)<<"\n"<<partonmomenta.back()<<"\n";

  pmg3[0][0]=pa.e();
  pmg3[0][1]=pa.x();
  pmg3[0][2]=pa.y();
  pmg3[0][3]=pa.z();
  
  pmg3[1][0]=pb.e();
  pmg3[1][1]=pb.x();
  pmg3[1][2]=pb.y();
  pmg3[1][3]=pb.z();
  
  pmg3[2][0]=pd2.e();   // -ve lepton
  pmg3[2][1]=pd2.x();
  pmg3[2][2]=pd2.y();
  pmg3[2][3]=pd2.z();
  
  pmg3[3][0]=pd1.e();   // anti-neutrino
  pmg3[3][1]=pd1.x();
  pmg3[3][2]=pd1.y();
  pmg3[3][3]=pd1.z();
  
  pmg3[4][0]=(partonmomenta.at(1)).e();   // middle
  pmg3[4][1]=(partonmomenta.at(1)).x();
  pmg3[4][2]=(partonmomenta.at(1)).y();
  pmg3[4][3]=(partonmomenta.at(1)).z();
  
  pmg3[5][0]=(partonmomenta.back()).e();  // most forward
  pmg3[5][1]=(partonmomenta.back()).x();
  pmg3[5][2]=(partonmomenta.back()).y();
  pmg3[5][3]=(partonmomenta.back()).z();
  
  pmg3[6][0]=(partonmomenta.front()).e();  // most backward jet
  pmg3[6][1]=(partonmomenta.front()).x();
  pmg3[6][2]=(partonmomenta.front()).y();
  pmg3[6][3]=(partonmomenta.front()).z();

  alepton.PID=-12;
  alepton.p=pd2;
  lepton.PID=11;
  lepton.p=pd1;
}

void CWMultijet::Def3jp12()
{
  //  std::cout<<pa<<"\n"<<pb<<"\n"<<pd1<<"\n"<<pd2<<"\n"<<partonmomenta.front()<<"\n"<<partonmomenta.at(1)<<"\n"<<partonmomenta.back()<<"\n";

  pmg3[0][0]=pa.e();
  pmg3[0][1]=pa.x();
  pmg3[0][2]=pa.y();
  pmg3[0][3]=pa.z();
  
  pmg3[1][0]=pb.e();
  pmg3[1][1]=pb.x();
  pmg3[1][2]=pb.y();
  pmg3[1][3]=pb.z();
  
  pmg3[2][0]=pd1.e();   // +ve lepton
  pmg3[2][1]=pd1.x();
  pmg3[2][2]=pd1.y();
  pmg3[2][3]=pd1.z();
  
  pmg3[3][0]=pd2.e();   // neutrino
  pmg3[3][1]=pd2.x();
  pmg3[3][2]=pd2.y();
  pmg3[3][3]=pd2.z();
  
  pmg3[4][0]=(partonmomenta.back()).e();   // most forward jet
  pmg3[4][1]=(partonmomenta.back()).x();
  pmg3[4][2]=(partonmomenta.back()).y();
  pmg3[4][3]=(partonmomenta.back()).z();
  
  pmg3[5][0]=(partonmomenta.front()).e();  // most backward
  pmg3[5][1]=(partonmomenta.front()).x();
  pmg3[5][2]=(partonmomenta.front()).y();
  pmg3[5][3]=(partonmomenta.front()).z();
  
  pmg3[6][0]=(partonmomenta.at(1)).e();  // middle
  pmg3[6][1]=(partonmomenta.at(1)).x();
  pmg3[6][2]=(partonmomenta.at(1)).y();
  pmg3[6][3]=(partonmomenta.at(1)).z();

  alepton.PID=-11;
  alepton.p=pd1;
  lepton.PID=12;
  lepton.p=pd2;
}

void CWMultijet::Def3jq12()
{
  //  std::cout<<pa<<"\n"<<pb<<"\n"<<pd1<<"\n"<<pd2<<"\n"<<partonmomenta.front()<<"\n"<<partonmomenta.at(1)<<"\n"<<partonmomenta.back()<<"\n";

  pmg3[0][0]=pa.e();
  pmg3[0][1]=pa.x();
  pmg3[0][2]=pa.y();
  pmg3[0][3]=pa.z();
  
  pmg3[1][0]=pb.e();
  pmg3[1][1]=pb.x();
  pmg3[1][2]=pb.y();
  pmg3[1][3]=pb.z();
  
  pmg3[2][0]=pd2.e();   // -ve lepton
  pmg3[2][1]=pd2.x();
  pmg3[2][2]=pd2.y();
  pmg3[2][3]=pd2.z();
  
  pmg3[3][0]=pd1.e();   // anti-neutrino
  pmg3[3][1]=pd1.x();
  pmg3[3][2]=pd1.y();
  pmg3[3][3]=pd1.z();
  
  pmg3[4][0]=(partonmomenta.back()).e();   // most forward jet
  pmg3[4][1]=(partonmomenta.back()).x();
  pmg3[4][2]=(partonmomenta.back()).y();
  pmg3[4][3]=(partonmomenta.back()).z();
  
  pmg3[5][0]=(partonmomenta.front()).e();  // most backward
  pmg3[5][1]=(partonmomenta.front()).x();
  pmg3[5][2]=(partonmomenta.front()).y();
  pmg3[5][3]=(partonmomenta.front()).z();
  
  pmg3[6][0]=(partonmomenta.at(1)).e();  // middle
  pmg3[6][1]=(partonmomenta.at(1)).x();
  pmg3[6][2]=(partonmomenta.at(1)).y();
  pmg3[6][3]=(partonmomenta.at(1)).z();

  alepton.PID=-12;
  alepton.p=pd2;
  lepton.PID=11;
  lepton.p=pd1;
}

  // p1  = b(+) a(-) --> e nu ++ + - --,   p2  = b(+) a(-) --> e nu ++ + -- -
  // p3  = b(+) a(-) --> e nu ++ - + --,   p4  = b(+) a(-) --> e nu ++ - -- +
  // p5  = b(+) a(-) --> e nu ++ -- + -,   p6  = b(+) a(-) --> e nu ++ -- - +
  // p7  = b(+) a(-) --> e nu + ++ - --,   p8  = b(+) a(-) --> e nu + ++ -- -
  // p9  = b(+) a(-) --> e nu + - ++ --,   p10 = b(+) a(-) --> e nu + - -- ++
  // p11 = b(+) a(-) --> e nu + -- ++ -,   p12 = b(+) a(-) --> e nu + -- - ++
  // p13 = b(+) a(-) --> e nu -- - + ++,   p14 = b(+) a(-) --> e nu -- - ++ +
  // p15 = b(+) a(-) --> e nu -- + - ++,   p16 = b(+) a(-) --> e nu -- + ++ -
  // p17 = b(+) a(-) --> e nu -- ++ - +,   p18 = b(+) a(-) --> e nu -- ++ + -
  // p19 = b(+) a(-) --> e nu - -- + ++,   p20 = b(+) a(-) --> e nu - -- ++ +
  // p21 = b(+) a(-) --> e nu - + -- ++,   p22 = b(+) a(-) --> e nu - + ++ --
  // p23 = b(+) a(-) --> e nu - ++ -- +,   p24 = b(+) a(-) --> e nu - ++ + --

  // p25 = a(-) b(+) --> e nu -- - + ++,   p26 = a(-) b(+) --> e nu -- - ++ +
  // p27 = a(-) b(+) --> e nu -- + - ++,   p28 = a(-) b(+) --> e nu -- + ++ -
  // p29 = a(-) b(+) --> e nu -- ++ - +,   p30 = a(-) b(+) --> e nu -- ++ + -
  // p31 = a(-) b(+) --> e nu - -- + ++,   p32 = a(-) b(+) --> e nu - -- ++ +
  // p33 = a(-) b(+) --> e nu - + -- ++,   p34 = a(-) b(+) --> e nu - + ++ --
  // p35 = a(-) b(+) --> e nu - ++ -- +,   p36 = a(-) b(+) --> e nu - ++ + --
  // p37 = a(-) b(+) --> e nu ++ + - --,   p38 = a(-) b(+) --> e nu ++ + -- -
  // p39 = a(-) b(+) --> e nu ++ - + --,   p40 = a(-) b(+) --> e nu ++ - -- +
  // p41 = a(-) b(+) --> e nu ++ -- + -,   p42 = a(-) b(+) --> e nu ++ -- - +
  // p43 = a(-) b(+) --> e nu + ++ - --,   p44 = a(-) b(+) --> e nu + ++ -- -
  // p45 = a(-) b(+) --> e nu + - ++ --,   p46 = a(-) b(+) --> e nu + - -- ++
  // p47 = a(-) b(+) --> e nu + -- ++ -,   p48 = a(-) b(+) --> e nu + -- - ++

  // qi = pi with e and nu swapped (for e- nubar final states)


#if new
double PickAndEvalProcAndMom2j(std::vector<sPMchoice> NonFKLProcesses, double p[4][4], particle * lepton, particle * alepton)
{
  static CLHEP::Ranlux64Engine ran;
  double pshuff[6][4];
  int ir1,ir2;
  int ProcessLength=NonFKLProcesses.size();
  ir1=int(ProcessLength*ran.flat());
  struct sPMchoice PMchoice=NonFKLProcesses[ir1];
  int MomChoiceLength=PMchoice.MomShuffleVector.size();
  ir2=int(MomChoiceLength*ran.flat());
  int momshuffle=PMchoice.MomShuffleVector[ir2];

  for (int ii=0;ii < 6; ii++) {
    pshuff[ii][0]=p[MDtemp2[momshuffle][ii]][0];
    pshuff[ii][1]=p[MDtemp2[momshuffle][ii]][1];
    pshuff[ii][2]=p[MDtemp2[momshuffle][ii]][2];
    pshuff[ii][3]=p[MDtemp2[momshuffle][ii]][3];
  }

  alepton->p=CLHEP::HepLorentzVector(pshuff[2][1],pshuff[2][2],pshuff[2][3],pshuff[2][0]);
  lepton->p=CLHEP::HepLorentzVector(pshuff[3][1],pshuff[3][2],pshuff[3][3],pshuff[3][0]);

  if (!PMchoice.ptype) { // process type p
    alepton->PID=-11;
    lepton->PID=12;
  } else {
    alepton->PID=-12;
    lepton->PID=11;
  }

  double ME2;
  PMchoice.MGfunc(&pshuff[0][0],&ME2);
  // std::cout<<"------------------------\n";
  // std::cout<<pshuff[0][3]<<"  "<<pshuff[1][3]<<"  "<<pshuff[2][3]<<"  "<<pshuff[3][3]<<"  "<<pshuff[4][3]<<"  "<<pshuff[5][3]<<"\n";
  // std::cout<<"ME2: "<<ME2<<"  "<<ME2*1.2177158*1.2177158*1.2177158*1.2177158<<"  "<<PMchoice.ptype<<"\n";
  // std::cout<<MomChoiceLength<<"  "<<ProcessLength<<"  "<<PMchoice.idpartmult<<"\n";
  return ME2*double(MomChoiceLength*ProcessLength*PMchoice.idpartmult);
}

double PickProcAndEval2j(std::vector<sPMchoice> NonFKLProcesses, double p[4][4], particle * lepton, particle * alepton)
{                        //  Where choice of process, but each with only one momentum
  static CLHEP::Ranlux64Engine ran;
  double pshuff[6][4];
  int ir1;
  int ProcessLength=NonFKLProcesses.size();
  if (ProcessLength>1)
    ir1=int(ProcessLength*ran.flat());
  else
    ir1=0;
  struct sPMchoice PMchoice=NonFKLProcesses[ir1];
  int momshuffle=PMchoice.MomShuffleVector[0];

  for (int ii=0;ii < 6; ii++) {
    pshuff[ii][0]=p[MDtemp2[momshuffle][ii]][0];
    pshuff[ii][1]=p[MDtemp2[momshuffle][ii]][1];
    pshuff[ii][2]=p[MDtemp2[momshuffle][ii]][2];
    pshuff[ii][3]=p[MDtemp2[momshuffle][ii]][3];
  }

  alepton->p=CLHEP::HepLorentzVector(pshuff[2][1],pshuff[2][2],pshuff[2][3],pshuff[2][0]);
  lepton->p=CLHEP::HepLorentzVector(pshuff[3][1],pshuff[3][2],pshuff[3][3],pshuff[3][0]);

  if (!PMchoice.ptype) { // process type p
    alepton->PID=-11;
    lepton->PID=12;
  } else {
    alepton->PID=-12;
    lepton->PID=11;
  }

  double ME2;
  PMchoice.MGfunc(&pshuff[0][0],&ME2);
  return ME2*double(ProcessLength*PMchoice.idpartmult);
}

double PickMomAndEval2j(std::vector<sPMchoice> NonFKLProcesses, double p[4][4], particle * lepton, particle * alepton)
{
  static CLHEP::Ranlux64Engine ran;
  double pshuff[6][4];
  struct sPMchoice PMchoice=NonFKLProcesses[0];
  int MomChoiceLength=PMchoice.MomShuffleVector.size();
  int ir2=int(MomChoiceLength*ran.flat());
  int momshuffle=PMchoice.MomShuffleVector[ir2];

  for (int ii=0;ii < 6; ii++) {
    pshuff[ii][0]=p[MDtemp2[momshuffle][ii]][0];
    pshuff[ii][1]=p[MDtemp2[momshuffle][ii]][1];
    pshuff[ii][2]=p[MDtemp2[momshuffle][ii]][2];
    pshuff[ii][3]=p[MDtemp2[momshuffle][ii]][3];
  }

  alepton->p=CLHEP::HepLorentzVector(pshuff[2][1],pshuff[2][2],pshuff[2][3],pshuff[2][0]);
  lepton->p=CLHEP::HepLorentzVector(pshuff[3][1],pshuff[3][2],pshuff[3][3],pshuff[3][0]);

  if (!PMchoice.ptype) { // process type p
    alepton->PID=-11;
    lepton->PID=12;
  } else {
    alepton->PID=-12;
    lepton->PID=11;
  }

  double ME2;
  PMchoice.MGfunc(&pshuff[0][0],&ME2);
  return ME2*double(MomChoiceLength*PMchoice.idpartmult);
}

double NoPickButEval2j(std::vector<sPMchoice> NonFKLProcesses, double p[4][4], particle * lepton, particle * alepton)
{
  static CLHEP::Ranlux64Engine ran;
  double pshuff[6][4];
  struct sPMchoice PMchoice=NonFKLProcesses[0];
  int momshuffle=PMchoice.MomShuffleVector[0];

  for (int ii=0;ii < 6; ii++) {
    pshuff[ii][0]=p[MDtemp2[momshuffle][ii]][0];
    pshuff[ii][1]=p[MDtemp2[momshuffle][ii]][1];
    pshuff[ii][2]=p[MDtemp2[momshuffle][ii]][2];
    pshuff[ii][3]=p[MDtemp2[momshuffle][ii]][3];
  }

  alepton->p=CLHEP::HepLorentzVector(pshuff[2][1],pshuff[2][2],pshuff[2][3],pshuff[2][0]);
  lepton->p=CLHEP::HepLorentzVector(pshuff[3][1],pshuff[3][2],pshuff[3][3],pshuff[3][0]);

  if (!PMchoice.ptype) { // process type p
    alepton->PID=-11;
    lepton->PID=12;
  } else {
    alepton->PID=-12;
    lepton->PID=11;
  }

  double ME2;
  PMchoice.MGfunc(&pshuff[0][0],&ME2);
  return ME2*double(PMchoice.idpartmult);
}

double PickAndEvalProcAndMom3j(std::vector<sPMchoice> NonFKLProcesses, double p[7][4], particle * lepton, particle * alepton)
{
  static CLHEP::Ranlux64Engine ran;
  double pshuff[7][4];
  int ProcessLength=NonFKLProcesses.size();
  int ir1=int(ProcessLength*ran.flat());
  struct sPMchoice PMchoice=NonFKLProcesses[ir1];
  int MomChoiceLength=PMchoice.MomShuffleVector.size();
  int ir2=int(MomChoiceLength*ran.flat());
  int momshuffle=PMchoice.MomShuffleVector[ir2];

  for (int ii=0;ii < 7; ii++) {
    pshuff[ii][0]=p[MDtemp3[momshuffle][ii]][0];
    pshuff[ii][1]=p[MDtemp3[momshuffle][ii]][1];
    pshuff[ii][2]=p[MDtemp3[momshuffle][ii]][2];
    pshuff[ii][3]=p[MDtemp3[momshuffle][ii]][3];
  }

  alepton->p=CLHEP::HepLorentzVector(pshuff[2][1],pshuff[2][2],pshuff[2][3],pshuff[2][0]);
  lepton->p=CLHEP::HepLorentzVector(pshuff[3][1],pshuff[3][2],pshuff[3][3],pshuff[3][0]);

  if (!PMchoice.ptype) { // process type p
    alepton->PID=-11;
    lepton->PID=12;
  } else {
    alepton->PID=-12;
    lepton->PID=11;
  }

  double ME2;
  PMchoice.MGfunc(&pshuff[0][0],&ME2);
  //  std::cout<<ME2<<"  "<<pshuff[0][0]<<"  "<<pshuff[1][0]<<"  "<<pshuff[2][0]<<"  "<<pshuff[3][0]<<"  "<<pshuff[4][0]<<"  "<<pshuff[5][0]<<"  "<<pshuff[6][0]<<"  "<<MomChoiceLength<<"  "<<ProcessLength<<"  "<<PMchoice.idpartmult<<std::endl;
  return ME2*double(MomChoiceLength*ProcessLength*PMchoice.idpartmult);
}

double PickMomAndEval3j(std::vector<sPMchoice> NonFKLProcesses, double p[7][4], particle * lepton, particle * alepton)
{
  static CLHEP::Ranlux64Engine ran;
  double pshuff[7][4];
  struct sPMchoice PMchoice=NonFKLProcesses[0];
  int MomChoiceLength=PMchoice.MomShuffleVector.size();
  int ir2=int(MomChoiceLength*ran.flat());
  int momshuffle=PMchoice.MomShuffleVector[ir2];

  for (int ii=0;ii < 7; ii++) {
    pshuff[ii][0]=p[MDtemp3[momshuffle][ii]][0];
    pshuff[ii][1]=p[MDtemp3[momshuffle][ii]][1];
    pshuff[ii][2]=p[MDtemp3[momshuffle][ii]][2];
    pshuff[ii][3]=p[MDtemp3[momshuffle][ii]][3];
  }

  alepton->p=CLHEP::HepLorentzVector(pshuff[2][1],pshuff[2][2],pshuff[2][3],pshuff[2][0]);
  lepton->p=CLHEP::HepLorentzVector(pshuff[3][1],pshuff[3][2],pshuff[3][3],pshuff[3][0]);

  if (!PMchoice.ptype) { // process type p
    alepton->PID=-11;
    lepton->PID=12;
  } else {
    alepton->PID=-12;
    lepton->PID=11;
  }

  double ME2;
  PMchoice.MGfunc(&pshuff[0][0],&ME2);
  return ME2*double(MomChoiceLength*PMchoice.idpartmult);
}

double PickAndEvalProcAndMom4j(std::vector<sPMchoice> NonFKLProcesses, double p[8][4], particle * lepton, particle * alepton)
{
  static CLHEP::Ranlux64Engine ran;
  double pshuff[8][4];
  int ProcessLength=NonFKLProcesses.size();
  int ir1=int(ProcessLength*ran.flat());
  struct sPMchoice PMchoice=NonFKLProcesses[ir1];
  int MomChoiceLength=PMchoice.MomShuffleVector.size();
  int ir2=int(MomChoiceLength*ran.flat());
  int momshuffle=PMchoice.MomShuffleVector[ir2];

  for (int ii=0;ii < 8; ii++) {
    pshuff[ii][0]=p[MDtemp[momshuffle][ii]][0];
    pshuff[ii][1]=p[MDtemp[momshuffle][ii]][1];
    pshuff[ii][2]=p[MDtemp[momshuffle][ii]][2];
    pshuff[ii][3]=p[MDtemp[momshuffle][ii]][3];
  }

  alepton->p=CLHEP::HepLorentzVector(pshuff[2][1],pshuff[2][2],pshuff[2][3],pshuff[2][0]);
  lepton->p=CLHEP::HepLorentzVector(pshuff[3][1],pshuff[3][2],pshuff[3][3],pshuff[3][0]);

  if (!PMchoice.ptype) { // process type p
    alepton->PID=-11;
    lepton->PID=12;
  } else {
    alepton->PID=-12;
    lepton->PID=11;
  }

  double ME2;
  PMchoice.MGfunc(&pshuff[0][0],&ME2);
  //  std::cout<<ME2<<"  "<<MomChoiceLength<<"  "<<ProcessLength<<"  "<<PMchoice.idpartmult<<"\n";
  //  std::cout<<momshuffle<<"  "<<pshuff[0][3]<<"  "<<pshuff[1][3]<<"  "<<pshuff[2][3]<<"  "<<pshuff[3][3]<<"  "<<pshuff[4][3]<<"  "<<pshuff[5][3]<<"  "<<pshuff[6][3]<<"  "<<pshuff[7][3]<<"\n";
  return ME2*double(MomChoiceLength*ProcessLength*PMchoice.idpartmult);
}
#else
void Def4jp1(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[0][0];
  pmg[0][1]=in[0][1];
  pmg[0][2]=in[0][2];
  pmg[0][3]=in[0][3];
  
  pmg[1][0]=in[1][0];
  pmg[1][1]=in[1][1];
  pmg[1][2]=in[1][2];
  pmg[1][3]=in[1][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[4][0];   // ++
  pmg[4][1]=in[4][1];
  pmg[4][2]=in[4][2];
  pmg[4][3]=in[4][3];
  
  pmg[5][0]=in[5][0];    // +
  pmg[5][1]=in[5][1];
  pmg[5][2]=in[5][2];
  pmg[5][3]=in[5][3];
  
  pmg[6][0]=in[6][0];    // -
  pmg[6][1]=in[6][1];
  pmg[6][2]=in[6][2];
  pmg[6][3]=in[6][3];
  
  pmg[7][0]=in[7][0];  // --
  pmg[7][1]=in[7][1];
  pmg[7][2]=in[7][2];
  pmg[7][3]=in[7][3];

  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp2(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[0][0];
  pmg[0][1]=in[0][1];
  pmg[0][2]=in[0][2];
  pmg[0][3]=in[0][3];
     	              
  pmg[1][0]=in[1][0];
  pmg[1][1]=in[1][1];
  pmg[1][2]=in[1][2];
  pmg[1][3]=in[1][3];
     	              
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
     	              
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
     	              
  pmg[4][0]=in[4][0];   // ++
  pmg[4][1]=in[4][1];
  pmg[4][2]=in[4][2];
  pmg[4][3]=in[4][3];
     	              
  pmg[5][0]=in[5][0];    // +
  pmg[5][1]=in[5][1];
  pmg[5][2]=in[5][2];
  pmg[5][3]=in[5][3];
     	              
  pmg[6][0]=in[7][0];    // --
  pmg[6][1]=in[7][1];
  pmg[6][2]=in[7][2];
  pmg[6][3]=in[7][3];
     	              
  pmg[7][0]=in[6][0];  // -
  pmg[7][1]=in[6][1];
  pmg[7][2]=in[6][2];
  pmg[7][3]=in[6][3];

  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp3(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[0][0];
  pmg[0][1]=in[0][1];
  pmg[0][2]=in[0][2];
  pmg[0][3]=in[0][3];
     	              
  pmg[1][0]=in[1][0];
  pmg[1][1]=in[1][1];
  pmg[1][2]=in[1][2];
  pmg[1][3]=in[1][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  	             
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[4][0];   // ++
  pmg[4][1]=in[4][1];
  pmg[4][2]=in[4][2];
  pmg[4][3]=in[4][3];
  	             
  pmg[5][0]=in[6][0];  // -
  pmg[5][1]=in[6][1];
  pmg[5][2]=in[6][2];
  pmg[5][3]=in[6][3];
  	             
  pmg[6][0]=in[5][0];  // +
  pmg[6][1]=in[5][1];
  pmg[6][2]=in[5][2];
  pmg[6][3]=in[5][3];
  	             
  pmg[7][0]=in[7][0];  // --
  pmg[7][1]=in[7][1];
  pmg[7][2]=in[7][2];
  pmg[7][3]=in[7][3];

  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp4(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[0][0];
  pmg[0][1]=in[0][1];
  pmg[0][2]=in[0][2];
  pmg[0][3]=in[0][3];
     	              
  pmg[1][0]=in[1][0];
  pmg[1][1]=in[1][1];
  pmg[1][2]=in[1][2];
  pmg[1][3]=in[1][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  	             
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[4][0];   // ++
  pmg[4][1]=in[4][1];
  pmg[4][2]=in[4][2];
  pmg[4][3]=in[4][3];
  
  pmg[5][0]=in[6][0];    // -
  pmg[5][1]=in[6][1];
  pmg[5][2]=in[6][2];
  pmg[5][3]=in[6][3];
  
  pmg[6][0]=in[7][0];    // --
  pmg[6][1]=in[7][1];
  pmg[6][2]=in[7][2];
  pmg[6][3]=in[7][3];
  
  pmg[7][0]=in[5][0];  // +
  pmg[7][1]=in[5][1];
  pmg[7][2]=in[5][2];
  pmg[7][3]=in[5][3];

  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp5(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[0][0];
  pmg[0][1]=in[0][1];
  pmg[0][2]=in[0][2];
  pmg[0][3]=in[0][3];
  	             
  pmg[1][0]=in[1][0];
  pmg[1][1]=in[1][1];
  pmg[1][2]=in[1][2];
  pmg[1][3]=in[1][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  	             
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[4][0];   // ++
  pmg[4][1]=in[4][1];
  pmg[4][2]=in[4][2];
  pmg[4][3]=in[4][3];
  
  pmg[5][0]=in[7][0];    // --
  pmg[5][1]=in[7][1];
  pmg[5][2]=in[7][2];
  pmg[5][3]=in[7][3];
  
  pmg[6][0]=in[5][0];    // +
  pmg[6][1]=in[5][1];
  pmg[6][2]=in[5][2];
  pmg[6][3]=in[5][3];
  
  pmg[7][0]=in[6][0];  // -
  pmg[7][1]=in[6][1];
  pmg[7][2]=in[6][2];
  pmg[7][3]=in[6][3];

  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp6(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[0][0];
  pmg[0][1]=in[0][1];
  pmg[0][2]=in[0][2];
  pmg[0][3]=in[0][3];
  	             
  pmg[1][0]=in[1][0];
  pmg[1][1]=in[1][1];
  pmg[1][2]=in[1][2];
  pmg[1][3]=in[1][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  	             
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[4][0];   // ++
  pmg[4][1]=in[4][1];
  pmg[4][2]=in[4][2];
  pmg[4][3]=in[4][3];
  
  pmg[5][0]=in[7][0];    // --
  pmg[5][1]=in[7][1];
  pmg[5][2]=in[7][2];
  pmg[5][3]=in[7][3];
  
  pmg[6][0]=in[6][0];    // -
  pmg[6][1]=in[6][1];
  pmg[6][2]=in[6][2];
  pmg[6][3]=in[6][3];
  
  pmg[7][0]=in[5][0];  // +
  pmg[7][1]=in[5][1];
  pmg[7][2]=in[5][2];
  pmg[7][3]=in[5][3];

  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp7(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[0][0];
  pmg[0][1]=in[0][1];
  pmg[0][2]=in[0][2];
  pmg[0][3]=in[0][3];
  	             
  pmg[1][0]=in[1][0];
  pmg[1][1]=in[1][1];
  pmg[1][2]=in[1][2];
  pmg[1][3]=in[1][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  	             
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[5][0];   // +
  pmg[4][1]=in[5][1];
  pmg[4][2]=in[5][2];
  pmg[4][3]=in[5][3];
  
  pmg[5][0]=in[4][0];    // ++
  pmg[5][1]=in[4][1];
  pmg[5][2]=in[4][2];
  pmg[5][3]=in[4][3];
  
  pmg[6][0]=in[6][0];    // -
  pmg[6][1]=in[6][1];
  pmg[6][2]=in[6][2];
  pmg[6][3]=in[6][3];
  
  pmg[7][0]=in[7][0];  // --
  pmg[7][1]=in[7][1];
  pmg[7][2]=in[7][2];
  pmg[7][3]=in[7][3];

  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp8(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[0][0];
  pmg[0][1]=in[0][1];
  pmg[0][2]=in[0][2];
  pmg[0][3]=in[0][3];
  	             
  pmg[1][0]=in[1][0];
  pmg[1][1]=in[1][1];
  pmg[1][2]=in[1][2];
  pmg[1][3]=in[1][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  	             
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[5][0];   // +
  pmg[4][1]=in[5][1];
  pmg[4][2]=in[5][2];
  pmg[4][3]=in[5][3];
  
  pmg[5][0]=in[4][0];    // ++
  pmg[5][1]=in[4][1];
  pmg[5][2]=in[4][2];
  pmg[5][3]=in[4][3];
  
  pmg[6][0]=in[7][0];    // --
  pmg[6][1]=in[7][1];
  pmg[6][2]=in[7][2];
  pmg[6][3]=in[7][3];
  
  pmg[7][0]=in[6][0];  // -
  pmg[7][1]=in[6][1];
  pmg[7][2]=in[6][2];
  pmg[7][3]=in[6][3];

  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp9(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[0][0];
  pmg[0][1]=in[0][1];
  pmg[0][2]=in[0][2];
  pmg[0][3]=in[0][3];
  	             
  pmg[1][0]=in[1][0];
  pmg[1][1]=in[1][1];
  pmg[1][2]=in[1][2];
  pmg[1][3]=in[1][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  	             
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[5][0];    // +
  pmg[4][1]=in[5][1];
  pmg[4][2]=in[5][2];
  pmg[4][3]=in[5][3];
  
  pmg[5][0]=in[6][0];    // -
  pmg[5][1]=in[6][1];
  pmg[5][2]=in[6][2];
  pmg[5][3]=in[6][3];
  
  pmg[6][0]=in[4][0];   // ++
  pmg[6][1]=in[4][1];
  pmg[6][2]=in[4][2];
  pmg[6][3]=in[4][3];
  
  pmg[7][0]=in[7][0];  // --
  pmg[7][1]=in[7][1];
  pmg[7][2]=in[7][2];
  pmg[7][3]=in[7][3];

  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp10(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[0][0];
  pmg[0][1]=in[0][1];
  pmg[0][2]=in[0][2];
  pmg[0][3]=in[0][3];
  
  pmg[1][0]=in[1][0];
  pmg[1][1]=in[1][1];
  pmg[1][2]=in[1][2];
  pmg[1][3]=in[1][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[5][0];    // +
  pmg[4][1]=in[5][1];
  pmg[4][2]=in[5][2];
  pmg[4][3]=in[5][3];
  
  pmg[5][0]=in[6][0];    // -
  pmg[5][1]=in[6][1];
  pmg[5][2]=in[6][2];
  pmg[5][3]=in[6][3];
  
  pmg[6][0]=in[7][0];  // --
  pmg[6][1]=in[7][1];
  pmg[6][2]=in[7][2];
  pmg[6][3]=in[7][3];

  pmg[7][0]=in[4][0];   // ++
  pmg[7][1]=in[4][1];
  pmg[7][2]=in[4][2];
  pmg[7][3]=in[4][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp11(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[0][0];
  pmg[0][1]=in[0][1];
  pmg[0][2]=in[0][2];
  pmg[0][3]=in[0][3];
  
  pmg[1][0]=in[1][0];
  pmg[1][1]=in[1][1];
  pmg[1][2]=in[1][2];
  pmg[1][3]=in[1][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[5][0];    // +
  pmg[4][1]=in[5][1];
  pmg[4][2]=in[5][2];
  pmg[4][3]=in[5][3];
  
  pmg[5][0]=in[7][0];  // --
  pmg[5][1]=in[7][1];
  pmg[5][2]=in[7][2];
  pmg[5][3]=in[7][3];

  pmg[6][0]=in[4][0];   // ++
  pmg[6][1]=in[4][1];
  pmg[6][2]=in[4][2];
  pmg[6][3]=in[4][3];
  
  pmg[7][0]=in[6][0];    // -
  pmg[7][1]=in[6][1];
  pmg[7][2]=in[6][2];
  pmg[7][3]=in[6][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp12(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[0][0];
  pmg[0][1]=in[0][1];
  pmg[0][2]=in[0][2];
  pmg[0][3]=in[0][3];
  
  pmg[1][0]=in[1][0];
  pmg[1][1]=in[1][1];
  pmg[1][2]=in[1][2];
  pmg[1][3]=in[1][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[5][0];    // +
  pmg[4][1]=in[5][1];
  pmg[4][2]=in[5][2];
  pmg[4][3]=in[5][3];
  
  pmg[5][0]=in[7][0];  // --
  pmg[5][1]=in[7][1];
  pmg[5][2]=in[7][2];
  pmg[5][3]=in[7][3];

  pmg[6][0]=in[6][0];    // -
  pmg[6][1]=in[6][1];
  pmg[6][2]=in[6][2];
  pmg[6][3]=in[6][3];
  
  pmg[7][0]=in[4][0];   // ++
  pmg[7][1]=in[4][1];
  pmg[7][2]=in[4][2];
  pmg[7][3]=in[4][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp13(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[0][0];
  pmg[0][1]=in[0][1];
  pmg[0][2]=in[0][2];
  pmg[0][3]=in[0][3];
  
  pmg[1][0]=in[1][0];
  pmg[1][1]=in[1][1];
  pmg[1][2]=in[1][2];
  pmg[1][3]=in[1][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[7][0];    // --
  pmg[4][1]=in[7][1];
  pmg[4][2]=in[7][2];
  pmg[4][3]=in[7][3];
  
  pmg[5][0]=in[6][0];    // -
  pmg[5][1]=in[6][1];
  pmg[5][2]=in[6][2];
  pmg[5][3]=in[6][3];

  pmg[6][0]=in[5][0];    // +
  pmg[6][1]=in[5][1];
  pmg[6][2]=in[5][2];
  pmg[6][3]=in[5][3];
  
  pmg[7][0]=in[4][0];   // ++
  pmg[7][1]=in[4][1];
  pmg[7][2]=in[4][2];
  pmg[7][3]=in[4][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp14(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[0][0];
  pmg[0][1]=in[0][1];
  pmg[0][2]=in[0][2];
  pmg[0][3]=in[0][3];
  
  pmg[1][0]=in[1][0];
  pmg[1][1]=in[1][1];
  pmg[1][2]=in[1][2];
  pmg[1][3]=in[1][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[7][0];    // --
  pmg[4][1]=in[7][1];
  pmg[4][2]=in[7][2];
  pmg[4][3]=in[7][3];
  
  pmg[5][0]=in[6][0];   // -
  pmg[5][1]=in[6][1];
  pmg[5][2]=in[6][2];
  pmg[5][3]=in[6][3];

  pmg[6][0]=in[4][0];   // ++
  pmg[6][1]=in[4][1];
  pmg[6][2]=in[4][2];
  pmg[6][3]=in[4][3];
  
  pmg[7][0]=in[5][0];   // +
  pmg[7][1]=in[5][1];
  pmg[7][2]=in[5][2];
  pmg[7][3]=in[5][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp15(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[0][0];
  pmg[0][1]=in[0][1];
  pmg[0][2]=in[0][2];
  pmg[0][3]=in[0][3];
  
  pmg[1][0]=in[1][0];
  pmg[1][1]=in[1][1];
  pmg[1][2]=in[1][2];
  pmg[1][3]=in[1][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[7][0];   // --
  pmg[4][1]=in[7][1];
  pmg[4][2]=in[7][2];
  pmg[4][3]=in[7][3];
  
  pmg[5][0]=in[5][0];   // +
  pmg[5][1]=in[5][1];
  pmg[5][2]=in[5][2];
  pmg[5][3]=in[5][3];

  pmg[6][0]=in[6][0];   // -
  pmg[6][1]=in[6][1];
  pmg[6][2]=in[6][2];
  pmg[6][3]=in[6][3];
  
  pmg[7][0]=in[4][0];   // ++
  pmg[7][1]=in[4][1];
  pmg[7][2]=in[4][2];
  pmg[7][3]=in[4][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp16(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[0][0];
  pmg[0][1]=in[0][1];
  pmg[0][2]=in[0][2];
  pmg[0][3]=in[0][3];
  
  pmg[1][0]=in[1][0];
  pmg[1][1]=in[1][1];
  pmg[1][2]=in[1][2];
  pmg[1][3]=in[1][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[7][0];   // --
  pmg[4][1]=in[7][1];
  pmg[4][2]=in[7][2];
  pmg[4][3]=in[7][3];
  
  pmg[5][0]=in[5][0];   // +
  pmg[5][1]=in[5][1];
  pmg[5][2]=in[5][2];
  pmg[5][3]=in[5][3];

  pmg[6][0]=in[4][0];   // ++
  pmg[6][1]=in[4][1];
  pmg[6][2]=in[4][2];
  pmg[6][3]=in[4][3];
  
  pmg[7][0]=in[6][0];   // -
  pmg[7][1]=in[6][1];
  pmg[7][2]=in[6][2];
  pmg[7][3]=in[6][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp17(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[0][0];
  pmg[0][1]=in[0][1];
  pmg[0][2]=in[0][2];
  pmg[0][3]=in[0][3];
  
  pmg[1][0]=in[1][0];
  pmg[1][1]=in[1][1];
  pmg[1][2]=in[1][2];
  pmg[1][3]=in[1][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[7][0];   // --
  pmg[4][1]=in[7][1];
  pmg[4][2]=in[7][2];
  pmg[4][3]=in[7][3];
  
  pmg[5][0]=in[4][0];   // ++
  pmg[5][1]=in[4][1];
  pmg[5][2]=in[4][2];
  pmg[5][3]=in[4][3];

  pmg[6][0]=in[6][0];   // -
  pmg[6][1]=in[6][1];
  pmg[6][2]=in[6][2];
  pmg[6][3]=in[6][3];
  
  pmg[7][0]=in[5][0];   // +
  pmg[7][1]=in[5][1];
  pmg[7][2]=in[5][2];
  pmg[7][3]=in[5][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp18(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[0][0];
  pmg[0][1]=in[0][1];
  pmg[0][2]=in[0][2];
  pmg[0][3]=in[0][3];
  
  pmg[1][0]=in[1][0];
  pmg[1][1]=in[1][1];
  pmg[1][2]=in[1][2];
  pmg[1][3]=in[1][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[7][0];   // --
  pmg[4][1]=in[7][1];
  pmg[4][2]=in[7][2];
  pmg[4][3]=in[7][3];
  
  pmg[5][0]=in[4][0];   // ++
  pmg[5][1]=in[4][1];
  pmg[5][2]=in[4][2];
  pmg[5][3]=in[4][3];

  pmg[6][0]=in[5][0];   // +
  pmg[6][1]=in[5][1];
  pmg[6][2]=in[5][2];
  pmg[6][3]=in[5][3];
  
  pmg[7][0]=in[6][0];   // -
  pmg[7][1]=in[6][1];
  pmg[7][2]=in[6][2];
  pmg[7][3]=in[6][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp19(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[0][0];
  pmg[0][1]=in[0][1];
  pmg[0][2]=in[0][2];
  pmg[0][3]=in[0][3];
  
  pmg[1][0]=in[1][0];
  pmg[1][1]=in[1][1];
  pmg[1][2]=in[1][2];
  pmg[1][3]=in[1][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[6][0];   // -
  pmg[4][1]=in[6][1];
  pmg[4][2]=in[6][2];
  pmg[4][3]=in[6][3];
  
  pmg[5][0]=in[7][0];   // --
  pmg[5][1]=in[7][1];
  pmg[5][2]=in[7][2];
  pmg[5][3]=in[7][3];

  pmg[6][0]=in[5][0];   // +
  pmg[6][1]=in[5][1];
  pmg[6][2]=in[5][2];
  pmg[6][3]=in[5][3];
  
  pmg[7][0]=in[4][0];   // ++
  pmg[7][1]=in[4][1];
  pmg[7][2]=in[4][2];
  pmg[7][3]=in[4][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp20(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[0][0];
  pmg[0][1]=in[0][1];
  pmg[0][2]=in[0][2];
  pmg[0][3]=in[0][3];
  
  pmg[1][0]=in[1][0];
  pmg[1][1]=in[1][1];
  pmg[1][2]=in[1][2];
  pmg[1][3]=in[1][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[6][0];   // -
  pmg[4][1]=in[6][1];
  pmg[4][2]=in[6][2];
  pmg[4][3]=in[6][3];
  
  pmg[5][0]=in[7][0];   // --
  pmg[5][1]=in[7][1];
  pmg[5][2]=in[7][2];
  pmg[5][3]=in[7][3];

  pmg[6][0]=in[4][0];   // ++
  pmg[6][1]=in[4][1];
  pmg[6][2]=in[4][2];
  pmg[6][3]=in[4][3];
  
  pmg[7][0]=in[5][0];   // +
  pmg[7][1]=in[5][1];
  pmg[7][2]=in[5][2];
  pmg[7][3]=in[5][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp21(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[0][0];
  pmg[0][1]=in[0][1];
  pmg[0][2]=in[0][2];
  pmg[0][3]=in[0][3];
  
  pmg[1][0]=in[1][0];
  pmg[1][1]=in[1][1];
  pmg[1][2]=in[1][2];
  pmg[1][3]=in[1][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[6][0];   // -
  pmg[4][1]=in[6][1];
  pmg[4][2]=in[6][2];
  pmg[4][3]=in[6][3];
  
  pmg[5][0]=in[5][0];   // +
  pmg[5][1]=in[5][1];
  pmg[5][2]=in[5][2];
  pmg[5][3]=in[5][3];

  pmg[6][0]=in[7][0];   // --
  pmg[6][1]=in[7][1];
  pmg[6][2]=in[7][2];
  pmg[6][3]=in[7][3];
  
  pmg[7][0]=in[4][0];   // ++
  pmg[7][1]=in[4][1];
  pmg[7][2]=in[4][2];
  pmg[7][3]=in[4][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp22(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[0][0];
  pmg[0][1]=in[0][1];
  pmg[0][2]=in[0][2];
  pmg[0][3]=in[0][3];
  
  pmg[1][0]=in[1][0];
  pmg[1][1]=in[1][1];
  pmg[1][2]=in[1][2];
  pmg[1][3]=in[1][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[6][0];   // -
  pmg[4][1]=in[6][1];
  pmg[4][2]=in[6][2];
  pmg[4][3]=in[6][3];
  
  pmg[5][0]=in[5][0];   // +
  pmg[5][1]=in[5][1];
  pmg[5][2]=in[5][2];
  pmg[5][3]=in[5][3];

  pmg[6][0]=in[4][0];   // ++
  pmg[6][1]=in[4][1];
  pmg[6][2]=in[4][2];
  pmg[6][3]=in[4][3];
  
  pmg[7][0]=in[7][0];   // --
  pmg[7][1]=in[7][1];
  pmg[7][2]=in[7][2];
  pmg[7][3]=in[7][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp23(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[0][0];
  pmg[0][1]=in[0][1];
  pmg[0][2]=in[0][2];
  pmg[0][3]=in[0][3];
  
  pmg[1][0]=in[1][0];
  pmg[1][1]=in[1][1];
  pmg[1][2]=in[1][2];
  pmg[1][3]=in[1][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[6][0];   // -
  pmg[4][1]=in[6][1];
  pmg[4][2]=in[6][2];
  pmg[4][3]=in[6][3];
  
  pmg[5][0]=in[4][0];   // ++
  pmg[5][1]=in[4][1];
  pmg[5][2]=in[4][2];
  pmg[5][3]=in[4][3];

  pmg[6][0]=in[7][0];   // --
  pmg[6][1]=in[7][1];
  pmg[6][2]=in[7][2];
  pmg[6][3]=in[7][3];
  
  pmg[7][0]=in[5][0];   // +
  pmg[7][1]=in[5][1];
  pmg[7][2]=in[5][2];
  pmg[7][3]=in[5][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp24(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[0][0];
  pmg[0][1]=in[0][1];
  pmg[0][2]=in[0][2];
  pmg[0][3]=in[0][3];
  
  pmg[1][0]=in[1][0];
  pmg[1][1]=in[1][1];
  pmg[1][2]=in[1][2];
  pmg[1][3]=in[1][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[6][0];   // -
  pmg[4][1]=in[6][1];
  pmg[4][2]=in[6][2];
  pmg[4][3]=in[6][3];
  
  pmg[5][0]=in[4][0];   // ++
  pmg[5][1]=in[4][1];
  pmg[5][2]=in[4][2];
  pmg[5][3]=in[4][3];

  pmg[6][0]=in[5][0];   // +
  pmg[6][1]=in[5][1];
  pmg[6][2]=in[5][2];
  pmg[6][3]=in[5][3];
  
  pmg[7][0]=in[7][0];   // --
  pmg[7][1]=in[7][1];
  pmg[7][2]=in[7][2];
  pmg[7][3]=in[7][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp25(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[1][0];
  pmg[0][1]=in[1][1];
  pmg[0][2]=in[1][2];
  pmg[0][3]=in[1][3];
  
  pmg[1][0]=in[0][0];
  pmg[1][1]=in[0][1];
  pmg[1][2]=in[0][2];
  pmg[1][3]=in[0][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[7][0];   // --
  pmg[4][1]=in[7][1];
  pmg[4][2]=in[7][2];
  pmg[4][3]=in[7][3];
  
  pmg[5][0]=in[6][0];    // -
  pmg[5][1]=in[6][1];
  pmg[5][2]=in[6][2];
  pmg[5][3]=in[6][3];
  
  pmg[6][0]=in[5][0];    // +
  pmg[6][1]=in[5][1];
  pmg[6][2]=in[5][2];
  pmg[6][3]=in[5][3];
  
  pmg[7][0]=in[4][0];  // ++
  pmg[7][1]=in[4][1];
  pmg[7][2]=in[4][2];
  pmg[7][3]=in[4][3];

  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp26(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[1][0];
  pmg[0][1]=in[1][1];
  pmg[0][2]=in[1][2];
  pmg[0][3]=in[1][3];
     	              
  pmg[1][0]=in[0][0];
  pmg[1][1]=in[0][1];
  pmg[1][2]=in[0][2];
  pmg[1][3]=in[0][3];
     	              
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
     	              
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
     	              
  pmg[4][0]=in[7][0];   // --
  pmg[4][1]=in[7][1];
  pmg[4][2]=in[7][2];
  pmg[4][3]=in[7][3];
     	              
  pmg[5][0]=in[6][0];    // -
  pmg[5][1]=in[6][1];
  pmg[5][2]=in[6][2];
  pmg[5][3]=in[6][3];
     	              
  pmg[6][0]=in[4][0];    // ++
  pmg[6][1]=in[4][1];
  pmg[6][2]=in[4][2];
  pmg[6][3]=in[4][3];
     	              
  pmg[7][0]=in[5][0];  // +
  pmg[7][1]=in[5][1];
  pmg[7][2]=in[5][2];
  pmg[7][3]=in[5][3];

  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp27(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[1][0];
  pmg[0][1]=in[1][1];
  pmg[0][2]=in[1][2];
  pmg[0][3]=in[1][3];
     	              
  pmg[1][0]=in[0][0];
  pmg[1][1]=in[0][1];
  pmg[1][2]=in[0][2];
  pmg[1][3]=in[0][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  	             
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[7][0];   // --
  pmg[4][1]=in[7][1];
  pmg[4][2]=in[7][2];
  pmg[4][3]=in[7][3];
  	             
  pmg[5][0]=in[5][0];  // +
  pmg[5][1]=in[5][1];
  pmg[5][2]=in[5][2];
  pmg[5][3]=in[5][3];
  	             
  pmg[6][0]=in[6][0];  // -
  pmg[6][1]=in[6][1];
  pmg[6][2]=in[6][2];
  pmg[6][3]=in[6][3];
  	             
  pmg[7][0]=in[4][0];  // ++
  pmg[7][1]=in[4][1];
  pmg[7][2]=in[4][2];
  pmg[7][3]=in[4][3];

  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp28(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[1][0];
  pmg[0][1]=in[1][1];
  pmg[0][2]=in[1][2];
  pmg[0][3]=in[1][3];
     	              
  pmg[1][0]=in[0][0];
  pmg[1][1]=in[0][1];
  pmg[1][2]=in[0][2];
  pmg[1][3]=in[0][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  	             
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[7][0];   // --
  pmg[4][1]=in[7][1];
  pmg[4][2]=in[7][2];
  pmg[4][3]=in[7][3];
  
  pmg[5][0]=in[5][0];    // +
  pmg[5][1]=in[5][1];
  pmg[5][2]=in[5][2];
  pmg[5][3]=in[5][3];
  
  pmg[6][0]=in[4][0];    // ++
  pmg[6][1]=in[4][1];
  pmg[6][2]=in[4][2];
  pmg[6][3]=in[4][3];
  
  pmg[7][0]=in[6][0];  // -
  pmg[7][1]=in[6][1];
  pmg[7][2]=in[6][2];
  pmg[7][3]=in[6][3];

  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp29(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[1][0];
  pmg[0][1]=in[1][1];
  pmg[0][2]=in[1][2];
  pmg[0][3]=in[1][3];
  	             
  pmg[1][0]=in[0][0];
  pmg[1][1]=in[0][1];
  pmg[1][2]=in[0][2];
  pmg[1][3]=in[0][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  	             
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[7][0];   // --
  pmg[4][1]=in[7][1];
  pmg[4][2]=in[7][2];
  pmg[4][3]=in[7][3];
  
  pmg[5][0]=in[4][0];    // ++
  pmg[5][1]=in[4][1];
  pmg[5][2]=in[4][2];
  pmg[5][3]=in[4][3];
  
  pmg[6][0]=in[6][0];    // -
  pmg[6][1]=in[6][1];
  pmg[6][2]=in[6][2];
  pmg[6][3]=in[6][3];
  
  pmg[7][0]=in[5][0];  // +
  pmg[7][1]=in[5][1];
  pmg[7][2]=in[5][2];
  pmg[7][3]=in[5][3];

  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp30(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[1][0];
  pmg[0][1]=in[1][1];
  pmg[0][2]=in[1][2];
  pmg[0][3]=in[1][3];
  	             
  pmg[1][0]=in[0][0];
  pmg[1][1]=in[0][1];
  pmg[1][2]=in[0][2];
  pmg[1][3]=in[0][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  	             
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[7][0];   // --
  pmg[4][1]=in[7][1];
  pmg[4][2]=in[7][2];
  pmg[4][3]=in[7][3];
  
  pmg[5][0]=in[4][0];    // ++
  pmg[5][1]=in[4][1];
  pmg[5][2]=in[4][2];
  pmg[5][3]=in[4][3];
  
  pmg[6][0]=in[5][0];    // +
  pmg[6][1]=in[5][1];
  pmg[6][2]=in[5][2];
  pmg[6][3]=in[5][3];
  
  pmg[7][0]=in[6][0];  // -
  pmg[7][1]=in[6][1];
  pmg[7][2]=in[6][2];
  pmg[7][3]=in[6][3];

  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp31(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[1][0];
  pmg[0][1]=in[1][1];
  pmg[0][2]=in[1][2];
  pmg[0][3]=in[1][3];
  	             
  pmg[1][0]=in[0][0];
  pmg[1][1]=in[0][1];
  pmg[1][2]=in[0][2];
  pmg[1][3]=in[0][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  	             
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[6][0];   // -
  pmg[4][1]=in[6][1];
  pmg[4][2]=in[6][2];
  pmg[4][3]=in[6][3];
  
  pmg[5][0]=in[7][0];    // --
  pmg[5][1]=in[7][1];
  pmg[5][2]=in[7][2];
  pmg[5][3]=in[7][3];
  
  pmg[6][0]=in[5][0];    // +
  pmg[6][1]=in[5][1];
  pmg[6][2]=in[5][2];
  pmg[6][3]=in[5][3];
  
  pmg[7][0]=in[4][0];  // ++
  pmg[7][1]=in[4][1];
  pmg[7][2]=in[4][2];
  pmg[7][3]=in[4][3];

  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp32(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[1][0];
  pmg[0][1]=in[1][1];
  pmg[0][2]=in[1][2];
  pmg[0][3]=in[1][3];
  	             
  pmg[1][0]=in[0][0];
  pmg[1][1]=in[0][1];
  pmg[1][2]=in[0][2];
  pmg[1][3]=in[0][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  	             
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[6][0];   // -
  pmg[4][1]=in[6][1];
  pmg[4][2]=in[6][2];
  pmg[4][3]=in[6][3];
  
  pmg[5][0]=in[7][0];    // --
  pmg[5][1]=in[7][1];
  pmg[5][2]=in[7][2];
  pmg[5][3]=in[7][3];
  
  pmg[6][0]=in[4][0];    // ++
  pmg[6][1]=in[4][1];
  pmg[6][2]=in[4][2];
  pmg[6][3]=in[4][3];
  
  pmg[7][0]=in[5][0];  // +
  pmg[7][1]=in[5][1];
  pmg[7][2]=in[5][2];
  pmg[7][3]=in[5][3];

  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp33(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[1][0];
  pmg[0][1]=in[1][1];
  pmg[0][2]=in[1][2];
  pmg[0][3]=in[1][3];
  	             
  pmg[1][0]=in[0][0];
  pmg[1][1]=in[0][1];
  pmg[1][2]=in[0][2];
  pmg[1][3]=in[0][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  	             
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[6][0];    // -
  pmg[4][1]=in[6][1];
  pmg[4][2]=in[6][2];
  pmg[4][3]=in[6][3];
  
  pmg[5][0]=in[5][0];    // +
  pmg[5][1]=in[5][1];
  pmg[5][2]=in[5][2];
  pmg[5][3]=in[5][3];
  
  pmg[6][0]=in[7][0];   // --
  pmg[6][1]=in[7][1];
  pmg[6][2]=in[7][2];
  pmg[6][3]=in[7][3];
  
  pmg[7][0]=in[4][0];  // ++
  pmg[7][1]=in[4][1];
  pmg[7][2]=in[4][2];
  pmg[7][3]=in[4][3];

  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp34(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[1][0];
  pmg[0][1]=in[1][1];
  pmg[0][2]=in[1][2];
  pmg[0][3]=in[1][3];
  
  pmg[1][0]=in[0][0];
  pmg[1][1]=in[0][1];
  pmg[1][2]=in[0][2];
  pmg[1][3]=in[0][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[6][0];    // -
  pmg[4][1]=in[6][1];
  pmg[4][2]=in[6][2];
  pmg[4][3]=in[6][3];
  
  pmg[5][0]=in[5][0];    // +
  pmg[5][1]=in[5][1];
  pmg[5][2]=in[5][2];
  pmg[5][3]=in[5][3];
  
  pmg[6][0]=in[4][0];  // ++
  pmg[6][1]=in[4][1];
  pmg[6][2]=in[4][2];
  pmg[6][3]=in[4][3];

  pmg[7][0]=in[7][0];   // --
  pmg[7][1]=in[7][1];
  pmg[7][2]=in[7][2];
  pmg[7][3]=in[7][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp35(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[1][0];
  pmg[0][1]=in[1][1];
  pmg[0][2]=in[1][2];
  pmg[0][3]=in[1][3];
  
  pmg[1][0]=in[0][0];
  pmg[1][1]=in[0][1];
  pmg[1][2]=in[0][2];
  pmg[1][3]=in[0][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[6][0];    // -
  pmg[4][1]=in[6][1];
  pmg[4][2]=in[6][2];
  pmg[4][3]=in[6][3];
  
  pmg[5][0]=in[4][0];  // ++
  pmg[5][1]=in[4][1];
  pmg[5][2]=in[4][2];
  pmg[5][3]=in[4][3];

  pmg[6][0]=in[7][0];   // --
  pmg[6][1]=in[7][1];
  pmg[6][2]=in[7][2];
  pmg[6][3]=in[7][3];
  
  pmg[7][0]=in[5][0];    // +
  pmg[7][1]=in[5][1];
  pmg[7][2]=in[5][2];
  pmg[7][3]=in[5][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp36(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[1][0];
  pmg[0][1]=in[1][1];
  pmg[0][2]=in[1][2];
  pmg[0][3]=in[1][3];
  
  pmg[1][0]=in[0][0];
  pmg[1][1]=in[0][1];
  pmg[1][2]=in[0][2];
  pmg[1][3]=in[0][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[6][0];    // -
  pmg[4][1]=in[6][1];
  pmg[4][2]=in[6][2];
  pmg[4][3]=in[6][3];
  
  pmg[5][0]=in[4][0];  // ++
  pmg[5][1]=in[4][1];
  pmg[5][2]=in[4][2];
  pmg[5][3]=in[4][3];

  pmg[6][0]=in[5][0];    // +
  pmg[6][1]=in[5][1];
  pmg[6][2]=in[5][2];
  pmg[6][3]=in[5][3];
  
  pmg[7][0]=in[7][0];   // --
  pmg[7][1]=in[7][1];
  pmg[7][2]=in[7][2];
  pmg[7][3]=in[7][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp37(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[1][0];
  pmg[0][1]=in[1][1];
  pmg[0][2]=in[1][2];
  pmg[0][3]=in[1][3];
  
  pmg[1][0]=in[0][0];
  pmg[1][1]=in[0][1];
  pmg[1][2]=in[0][2];
  pmg[1][3]=in[0][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[4][0];    // ++
  pmg[4][1]=in[4][1];
  pmg[4][2]=in[4][2];
  pmg[4][3]=in[4][3];
  
  pmg[5][0]=in[5][0];    // +
  pmg[5][1]=in[5][1];
  pmg[5][2]=in[5][2];
  pmg[5][3]=in[5][3];

  pmg[6][0]=in[6][0];    // -
  pmg[6][1]=in[6][1];
  pmg[6][2]=in[6][2];
  pmg[6][3]=in[6][3];
  
  pmg[7][0]=in[7][0];   // --
  pmg[7][1]=in[7][1];
  pmg[7][2]=in[7][2];
  pmg[7][3]=in[7][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp38(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[1][0];
  pmg[0][1]=in[1][1];
  pmg[0][2]=in[1][2];
  pmg[0][3]=in[1][3];
  
  pmg[1][0]=in[0][0];
  pmg[1][1]=in[0][1];
  pmg[1][2]=in[0][2];
  pmg[1][3]=in[0][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[4][0];    // ++
  pmg[4][1]=in[4][1];
  pmg[4][2]=in[4][2];
  pmg[4][3]=in[4][3];
  
  pmg[5][0]=in[5][0];   // +
  pmg[5][1]=in[5][1];
  pmg[5][2]=in[5][2];
  pmg[5][3]=in[5][3];

  pmg[6][0]=in[7][0];   // --
  pmg[6][1]=in[7][1];
  pmg[6][2]=in[7][2];
  pmg[6][3]=in[7][3];
  
  pmg[7][0]=in[6][0];   // -
  pmg[7][1]=in[6][1];
  pmg[7][2]=in[6][2];
  pmg[7][3]=in[6][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp39(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[1][0];
  pmg[0][1]=in[1][1];
  pmg[0][2]=in[1][2];
  pmg[0][3]=in[1][3];
  
  pmg[1][0]=in[0][0];
  pmg[1][1]=in[0][1];
  pmg[1][2]=in[0][2];
  pmg[1][3]=in[0][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[4][0];   // ++
  pmg[4][1]=in[4][1];
  pmg[4][2]=in[4][2];
  pmg[4][3]=in[4][3];
  
  pmg[5][0]=in[6][0];   // -
  pmg[5][1]=in[6][1];
  pmg[5][2]=in[6][2];
  pmg[5][3]=in[6][3];

  pmg[6][0]=in[5][0];   // +
  pmg[6][1]=in[5][1];
  pmg[6][2]=in[5][2];
  pmg[6][3]=in[5][3];
  
  pmg[7][0]=in[7][0];   // --
  pmg[7][1]=in[7][1];
  pmg[7][2]=in[7][2];
  pmg[7][3]=in[7][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp40(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[1][0];
  pmg[0][1]=in[1][1];
  pmg[0][2]=in[1][2];
  pmg[0][3]=in[1][3];
  
  pmg[1][0]=in[0][0];
  pmg[1][1]=in[0][1];
  pmg[1][2]=in[0][2];
  pmg[1][3]=in[0][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[4][0];   // ++
  pmg[4][1]=in[4][1];
  pmg[4][2]=in[4][2];
  pmg[4][3]=in[4][3];
  
  pmg[5][0]=in[6][0];   // -
  pmg[5][1]=in[6][1];
  pmg[5][2]=in[6][2];
  pmg[5][3]=in[6][3];

  pmg[6][0]=in[7][0];   // --
  pmg[6][1]=in[7][1];
  pmg[6][2]=in[7][2];
  pmg[6][3]=in[7][3];
  
  pmg[7][0]=in[5][0];   // +
  pmg[7][1]=in[5][1];
  pmg[7][2]=in[5][2];
  pmg[7][3]=in[5][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp41(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[1][0];
  pmg[0][1]=in[1][1];
  pmg[0][2]=in[1][2];
  pmg[0][3]=in[1][3];
  
  pmg[1][0]=in[0][0];
  pmg[1][1]=in[0][1];
  pmg[1][2]=in[0][2];
  pmg[1][3]=in[0][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[4][0];   // ++
  pmg[4][1]=in[4][1];
  pmg[4][2]=in[4][2];
  pmg[4][3]=in[4][3];
  
  pmg[5][0]=in[7][0];   // --
  pmg[5][1]=in[7][1];
  pmg[5][2]=in[7][2];
  pmg[5][3]=in[7][3];

  pmg[6][0]=in[5][0];   // +
  pmg[6][1]=in[5][1];
  pmg[6][2]=in[5][2];
  pmg[6][3]=in[5][3];
  
  pmg[7][0]=in[6][0];   // -
  pmg[7][1]=in[6][1];
  pmg[7][2]=in[6][2];
  pmg[7][3]=in[6][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp42(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[1][0];
  pmg[0][1]=in[1][1];
  pmg[0][2]=in[1][2];
  pmg[0][3]=in[1][3];
  
  pmg[1][0]=in[0][0];
  pmg[1][1]=in[0][1];
  pmg[1][2]=in[0][2];
  pmg[1][3]=in[0][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[4][0];   // ++
  pmg[4][1]=in[4][1];
  pmg[4][2]=in[4][2];
  pmg[4][3]=in[4][3];
  
  pmg[5][0]=in[7][0];   // --
  pmg[5][1]=in[7][1];
  pmg[5][2]=in[7][2];
  pmg[5][3]=in[7][3];

  pmg[6][0]=in[6][0];   // -
  pmg[6][1]=in[6][1];
  pmg[6][2]=in[6][2];
  pmg[6][3]=in[6][3];
  
  pmg[7][0]=in[5][0];   // +
  pmg[7][1]=in[5][1];
  pmg[7][2]=in[5][2];
  pmg[7][3]=in[5][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp43(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[1][0];
  pmg[0][1]=in[1][1];
  pmg[0][2]=in[1][2];
  pmg[0][3]=in[1][3];
  
  pmg[1][0]=in[0][0];
  pmg[1][1]=in[0][1];
  pmg[1][2]=in[0][2];
  pmg[1][3]=in[0][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[5][0];   // +
  pmg[4][1]=in[5][1];
  pmg[4][2]=in[5][2];
  pmg[4][3]=in[5][3];
  
  pmg[5][0]=in[4][0];   // ++
  pmg[5][1]=in[4][1];
  pmg[5][2]=in[4][2];
  pmg[5][3]=in[4][3];

  pmg[6][0]=in[6][0];   // -
  pmg[6][1]=in[6][1];
  pmg[6][2]=in[6][2];
  pmg[6][3]=in[6][3];
  
  pmg[7][0]=in[7][0];   // --
  pmg[7][1]=in[7][1];
  pmg[7][2]=in[7][2];
  pmg[7][3]=in[7][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp44(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[1][0];
  pmg[0][1]=in[1][1];
  pmg[0][2]=in[1][2];
  pmg[0][3]=in[1][3];
  
  pmg[1][0]=in[0][0];
  pmg[1][1]=in[0][1];
  pmg[1][2]=in[0][2];
  pmg[1][3]=in[0][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[5][0];   // +
  pmg[4][1]=in[5][1];
  pmg[4][2]=in[5][2];
  pmg[4][3]=in[5][3];
  
  pmg[5][0]=in[4][0];   // ++
  pmg[5][1]=in[4][1];
  pmg[5][2]=in[4][2];
  pmg[5][3]=in[4][3];

  pmg[6][0]=in[7][0];   // --
  pmg[6][1]=in[7][1];
  pmg[6][2]=in[7][2];
  pmg[6][3]=in[7][3];
  
  pmg[7][0]=in[6][0];   // -
  pmg[7][1]=in[6][1];
  pmg[7][2]=in[6][2];
  pmg[7][3]=in[6][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp45(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[1][0];
  pmg[0][1]=in[1][1];
  pmg[0][2]=in[1][2];
  pmg[0][3]=in[1][3];
  
  pmg[1][0]=in[0][0];
  pmg[1][1]=in[0][1];
  pmg[1][2]=in[0][2];
  pmg[1][3]=in[0][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[5][0];   // +
  pmg[4][1]=in[5][1];
  pmg[4][2]=in[5][2];
  pmg[4][3]=in[5][3];
  
  pmg[5][0]=in[6][0];   // -
  pmg[5][1]=in[6][1];
  pmg[5][2]=in[6][2];
  pmg[5][3]=in[6][3];

  pmg[6][0]=in[4][0];   // ++
  pmg[6][1]=in[4][1];
  pmg[6][2]=in[4][2];
  pmg[6][3]=in[4][3];
  
  pmg[7][0]=in[7][0];   // --
  pmg[7][1]=in[7][1];
  pmg[7][2]=in[7][2];
  pmg[7][3]=in[7][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp46(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[1][0];
  pmg[0][1]=in[1][1];
  pmg[0][2]=in[1][2];
  pmg[0][3]=in[1][3];
  
  pmg[1][0]=in[0][0];
  pmg[1][1]=in[0][1];
  pmg[1][2]=in[0][2];
  pmg[1][3]=in[0][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[5][0];   // +
  pmg[4][1]=in[5][1];
  pmg[4][2]=in[5][2];
  pmg[4][3]=in[5][3];
  
  pmg[5][0]=in[6][0];   // -
  pmg[5][1]=in[6][1];
  pmg[5][2]=in[6][2];
  pmg[5][3]=in[6][3];

  pmg[6][0]=in[7][0];   // --
  pmg[6][1]=in[7][1];
  pmg[6][2]=in[7][2];
  pmg[6][3]=in[7][3];
  
  pmg[7][0]=in[4][0];   // ++
  pmg[7][1]=in[4][1];
  pmg[7][2]=in[4][2];
  pmg[7][3]=in[4][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp47(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[1][0];
  pmg[0][1]=in[1][1];
  pmg[0][2]=in[1][2];
  pmg[0][3]=in[1][3];
  
  pmg[1][0]=in[0][0];
  pmg[1][1]=in[0][1];
  pmg[1][2]=in[0][2];
  pmg[1][3]=in[0][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[5][0];   // +
  pmg[4][1]=in[5][1];
  pmg[4][2]=in[5][2];
  pmg[4][3]=in[5][3];
  
  pmg[5][0]=in[7][0];   // --
  pmg[5][1]=in[7][1];
  pmg[5][2]=in[7][2];
  pmg[5][3]=in[7][3];

  pmg[6][0]=in[4][0];   // ++
  pmg[6][1]=in[4][1];
  pmg[6][2]=in[4][2];
  pmg[6][3]=in[4][3];
  
  pmg[7][0]=in[6][0];   // -
  pmg[7][1]=in[6][1];
  pmg[7][2]=in[6][2];
  pmg[7][3]=in[6][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

void Def4jp48(double in[][4],double pmg[][4],particle * lepton, particle * alepton)
{
  pmg[0][0]=in[1][0];
  pmg[0][1]=in[1][1];
  pmg[0][2]=in[1][2];
  pmg[0][3]=in[1][3];
  
  pmg[1][0]=in[0][0];
  pmg[1][1]=in[0][1];
  pmg[1][2]=in[0][2];
  pmg[1][3]=in[0][3];
  
  pmg[2][0]=in[2][0];   // +ve lepton
  pmg[2][1]=in[2][1];
  pmg[2][2]=in[2][2];
  pmg[2][3]=in[2][3];
  
  pmg[3][0]=in[3][0];   // neutrino
  pmg[3][1]=in[3][1];
  pmg[3][2]=in[3][2];
  pmg[3][3]=in[3][3];
  
  pmg[4][0]=in[5][0];   // +
  pmg[4][1]=in[5][1];
  pmg[4][2]=in[5][2];
  pmg[4][3]=in[5][3];
  
  pmg[5][0]=in[7][0];   // --
  pmg[5][1]=in[7][1];
  pmg[5][2]=in[7][2];
  pmg[5][3]=in[7][3];

  pmg[6][0]=in[6][0];   // -
  pmg[6][1]=in[6][1];
  pmg[6][2]=in[6][2];
  pmg[6][3]=in[6][3];
  
  pmg[7][0]=in[4][0];   // ++
  pmg[7][1]=in[4][1];
  pmg[7][2]=in[4][2];
  pmg[7][3]=in[4][3];
  
  alepton->PID=-11;
  alepton->p=CLHEP::HepLorentzVector(in[2][1],in[2][2],in[2][3],in[2][0]);
  lepton->PID=12;
  lepton->p=CLHEP::HepLorentzVector(in[3][1],in[3][2],in[3][3],in[3][0]);
}

double PickAndEvalProcAndMom4j(std::vector<sPMchoice> NonFKLProcesses, double p[8][4], particle * lepton, particle * alepton)
{
  static CLHEP::Ranlux64Engine ran;
  double pshuff[8][4];
  int ProcessLength=NonFKLProcesses.size();
  int ir1=int(ProcessLength*ran.flat());
  struct sPMchoice PMchoice=NonFKLProcesses[ir1];
  int MomChoiceLength=PMchoice.MomPickVector.size();
  int ir2=int(MomChoiceLength*ran.flat());
  PMchoice.MomPickVector[ir2](p,pshuff,lepton,alepton);
  // PMchoice.MomPickVector[ir2](&p[0][0],&pshuff[0][0],lepton,alepton);
  double ME2;
  PMchoice.MGfunc(&pshuff[0][0],&ME2);
  std::cout<<ME2<<"  "<<MomChoiceLength<<"  "<<ProcessLength<<"  "<<PMchoice.idpartmult<<"\n";
  return ME2*double(MomChoiceLength*ProcessLength*PMchoice.idpartmult);
}
#endif
